-- MySQL dump 10.11
--
-- Host: localhost    Database: call_center_pro
-- ------------------------------------------------------
-- Server version	5.0.95

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `agent`
--

CREATE DATABASE call_center_pro;

GRANT ALL ON `call_center_pro`.* to asteriskuser@localhost;

USE call_center_pro;

DROP TABLE IF EXISTS `agent`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `agent` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `type` enum('Agent','SIP','IAX2') NOT NULL default 'Agent',
  `number` varchar(40) NOT NULL,
  `name` varchar(250) NOT NULL,
  `password` varchar(250) NOT NULL,
  `estatus` enum('A','I') default 'A',
  `eccp_password` varchar(128) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=15 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `agent`
--

LOCK TABLES `agent` WRITE;
/*!40000 ALTER TABLE `agent` DISABLE KEYS */;
/*!40000 ALTER TABLE `agent` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `audit`
--

DROP TABLE IF EXISTS `audit`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `audit` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `id_agent` int(10) unsigned NOT NULL,
  `id_break` int(10) unsigned default NULL,
  `datetime_init` datetime NOT NULL,
  `datetime_end` datetime default NULL,
  `duration` time default NULL,
  `ext_parked` varchar(10) default NULL,
  PRIMARY KEY  (`id`),
  KEY `id_agent` (`id_agent`),
  KEY `id_break` (`id_break`),
  CONSTRAINT `audit_ibfk_1` FOREIGN KEY (`id_agent`) REFERENCES `agent` (`id`),
  CONSTRAINT `audit_ibfk_2` FOREIGN KEY (`id_break`) REFERENCES `break` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=45 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `audit`
--

LOCK TABLES `audit` WRITE;
/*!40000 ALTER TABLE `audit` DISABLE KEYS */;
/*!40000 ALTER TABLE `audit` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `break`
--

DROP TABLE IF EXISTS `break`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `break` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `name` varchar(250) NOT NULL,
  `description` varchar(250) default NULL,
  `status` varchar(1) NOT NULL default 'A',
  `tipo` enum('B','H') default 'B',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `break`
--

LOCK TABLES `break` WRITE;
/*!40000 ALTER TABLE `break` DISABLE KEYS */;
REPLACE INTO `break` VALUES (1,'Hold','Hold','A','H');
/*!40000 ALTER TABLE `break` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `call_attribute`
--

DROP TABLE IF EXISTS `call_attribute`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `call_attribute` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `id_call` int(10) unsigned NOT NULL,
  `columna` varchar(30) default NULL,
  `value` varchar(128) NOT NULL,
  `column_number` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`),
  KEY `id_call` (`id_call`),
  CONSTRAINT `call_attribute_ibfk_1` FOREIGN KEY (`id_call`) REFERENCES `calls` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `call_attribute`
--

LOCK TABLES `call_attribute` WRITE;
/*!40000 ALTER TABLE `call_attribute` DISABLE KEYS */;
/*!40000 ALTER TABLE `call_attribute` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `call_entry`
--

DROP TABLE IF EXISTS `call_entry`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `call_entry` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `id_agent` int(10) unsigned default NULL,
  `id_queue_call_entry` int(10) unsigned NOT NULL,
  `id_contact` int(10) unsigned default NULL,
  `callerid` varchar(15) NOT NULL,
  `datetime_init` datetime default NULL,
  `datetime_end` datetime default NULL,
  `duration` int(10) unsigned default NULL,
  `status` varchar(32) default NULL,
  `transfer` varchar(6) default NULL,
  `datetime_entry_queue` datetime default NULL,
  `duration_wait` int(11) default NULL,
  `uniqueid` varchar(32) default NULL,
  `id_campaign` int(10) unsigned default NULL,
  `trunk` varchar(20) NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `id_agent` (`id_agent`),
  KEY `id_queue_call_entry` (`id_queue_call_entry`),
  KEY `id_contact` (`id_contact`),
  KEY `call_entry_ibfk_4` (`id_campaign`),
  CONSTRAINT `call_entry_ibfk_1` FOREIGN KEY (`id_agent`) REFERENCES `agent` (`id`),
  CONSTRAINT `call_entry_ibfk_2` FOREIGN KEY (`id_queue_call_entry`) REFERENCES `queue_call_entry` (`id`),
  CONSTRAINT `call_entry_ibfk_3` FOREIGN KEY (`id_contact`) REFERENCES `contact` (`id`),
  CONSTRAINT `call_entry_ibfk_4` FOREIGN KEY (`id_campaign`) REFERENCES `campaign_entry` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=21 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `call_entry`
--

LOCK TABLES `call_entry` WRITE;
/*!40000 ALTER TABLE `call_entry` DISABLE KEYS */;
/*!40000 ALTER TABLE `call_entry` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `call_progress_log`
--

DROP TABLE IF EXISTS `call_progress_log`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `call_progress_log` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `datetime_entry` datetime NOT NULL,
  `id_campaign_incoming` int(10) unsigned default NULL,
  `id_call_incoming` int(10) unsigned default NULL,
  `id_campaign_outgoing` int(10) unsigned default NULL,
  `id_call_outgoing` int(10) unsigned default NULL,
  `new_status` varchar(32) NOT NULL,
  `retry` int(10) unsigned default NULL,
  `uniqueid` varchar(32) default NULL,
  `trunk` varchar(20) default NULL,
  `id_agent` int(10) unsigned default NULL,
  `duration` int(10) unsigned default NULL,
  PRIMARY KEY  (`id`),
  KEY `call_progress_log_ibfk_4` (`id_agent`),
  KEY `call_progress_log_ibfk_5` (`id_campaign_incoming`),
  KEY `call_progress_log_ibfk_6` (`id_campaign_outgoing`),
  KEY `incoming_datetime_entry` (`id_call_incoming`,`datetime_entry`),
  KEY `outgoing_datetime_entry` (`id_call_outgoing`,`datetime_entry`),
  CONSTRAINT `call_progress_log_ibfk_1` FOREIGN KEY (`id_call_incoming`) REFERENCES `call_entry` (`id`),
  CONSTRAINT `call_progress_log_ibfk_2` FOREIGN KEY (`id_call_outgoing`) REFERENCES `calls` (`id`),
  CONSTRAINT `call_progress_log_ibfk_4` FOREIGN KEY (`id_agent`) REFERENCES `agent` (`id`),
  CONSTRAINT `call_progress_log_ibfk_5` FOREIGN KEY (`id_campaign_incoming`) REFERENCES `campaign_entry` (`id`),
  CONSTRAINT `call_progress_log_ibfk_6` FOREIGN KEY (`id_campaign_outgoing`) REFERENCES `campaign` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=80 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `call_progress_log`
--

LOCK TABLES `call_progress_log` WRITE;
/*!40000 ALTER TABLE `call_progress_log` DISABLE KEYS */;
/*!40000 ALTER TABLE `call_progress_log` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `calls`
--

DROP TABLE IF EXISTS `calls`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `calls` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `id_campaign` int(10) unsigned NOT NULL,
  `phone` varchar(32) NOT NULL,
  `status` varchar(32) default NULL,
  `uniqueid` varchar(32) default NULL,
  `fecha_llamada` datetime default NULL,
  `start_time` datetime default NULL,
  `end_time` datetime default NULL,
  `retries` int(10) unsigned NOT NULL default '0',
  `duration` int(10) unsigned default NULL,
  `id_agent` int(10) unsigned default NULL,
  `transfer` varchar(6) default NULL,
  `datetime_entry_queue` datetime default NULL,
  `duration_wait` int(11) default NULL,
  `dnc` int(1) NOT NULL default '0',
  `date_init` date default NULL,
  `date_end` date default NULL,
  `time_init` time default NULL,
  `time_end` time default NULL,
  `agent` varchar(32) default NULL,
  `failure_cause` int(10) unsigned default NULL,
  `failure_cause_txt` varchar(32) default NULL,
  `datetime_originate` datetime default NULL,
  `trunk` varchar(20) default NULL,
  `amd_status` varchar(12) default NULL,
  `id_group` int(10) unsigned default NULL,
  `group_priority` tinyint(4) default NULL,
  `group_status` varchar(32) default NULL,
  PRIMARY KEY  (`id`),
  KEY `id_campaign` (`id_campaign`),
  KEY `calls_ibfk_2` (`id_agent`),
  KEY `calls_id_group` (`id_group`),
  CONSTRAINT `calls_ibfk_1` FOREIGN KEY (`id_campaign`) REFERENCES `campaign` (`id`),
  CONSTRAINT `calls_ibfk_2` FOREIGN KEY (`id_agent`) REFERENCES `agent` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `calls`
--

LOCK TABLES `calls` WRITE;
/*!40000 ALTER TABLE `calls` DISABLE KEYS */;
/*!40000 ALTER TABLE `calls` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `campaign`
--

DROP TABLE IF EXISTS `campaign`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `campaign` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `name` varchar(64) NOT NULL,
  `datetime_init` date NOT NULL,
  `datetime_end` date NOT NULL,
  `daytime_init` time NOT NULL,
  `daytime_end` time NOT NULL,
  `retries` int(10) unsigned NOT NULL default '1',
  `trunk` varchar(255) default NULL,
  `context` varchar(32) NOT NULL,
  `id_queue_call_entry` int(10) unsigned NOT NULL,
  `max_canales` int(10) unsigned NOT NULL default '0',
  `num_completadas` int(10) unsigned default NULL,
  `promedio` int(10) unsigned default NULL,
  `desviacion` int(10) unsigned default NULL,
  `script` text NOT NULL,
  `estatus` varchar(1) NOT NULL default 'A',
  `id_url` int(10) unsigned default NULL,
  `id_team` int(10) unsigned default NULL,
  PRIMARY KEY  (`id`),
  KEY `id_url` (`id_url`),
  KEY `id_team` (`id_team`),
  KEY `id_queue_call_entry` (`id_queue_call_entry`),
  CONSTRAINT `campaign_ibfk_1` FOREIGN KEY (`id_url`) REFERENCES `campaign_external_url` (`id`),
  CONSTRAINT `campaign_ibfk_2` FOREIGN KEY (`id_team`) REFERENCES `team` (`id`),
  CONSTRAINT `campaign_ibfk_3` FOREIGN KEY (`id_queue_call_entry`) REFERENCES `queue_call_entry` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `campaign`
--

LOCK TABLES `campaign` WRITE;
/*!40000 ALTER TABLE `campaign` DISABLE KEYS */;
/*!40000 ALTER TABLE `campaign` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `campaign_dynamic_form`
--

DROP TABLE IF EXISTS `campaign_dynamic_form`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `campaign_dynamic_form` (
  `id_campaign` int(10) unsigned default NULL,
  `id_dynamic_form` int(10) unsigned default NULL,
  KEY `id_campaign` (`id_campaign`),
  KEY `id_dynamic_form` (`id_dynamic_form`),
  CONSTRAINT `campaign_dynamic_form_ibfk_1` FOREIGN KEY (`id_campaign`) REFERENCES `campaign` (`id`),
  CONSTRAINT `campaign_dynamic_form_ibfk_2` FOREIGN KEY (`id_dynamic_form`) REFERENCES `dynamic_form` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=UTF8;
/*!40101 SET character_set_client = @saved_cs_client */;


DROP TABLE IF EXISTS `campaign_dynamic_form_entry`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `campaign_dynamic_form_entry` (
  `id_campaign_entry` int(10) unsigned default NULL,
  `id_dynamic_form` int(10) unsigned default NULL,
  KEY `id_campaign_entry` (`id_campaign_entry`),
  KEY `id_dynamic_form` (`id_dynamic_form`),
  CONSTRAINT `campaign_dynamic_form_entry_ibfk_1` FOREIGN KEY (`id_campaign_entry`) REFERENCES `campaign_entry` (`id`),
  CONSTRAINT `campaign_dynamic_form_entry_ibfk_2` FOREIGN KEY (`id_dynamic_form`) REFERENCES `dynamic_form` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=UTF8;

--
-- Dumping data for table `campaign_dynamic_form`
--

LOCK TABLES `campaign_dynamic_form` WRITE;
/*!40000 ALTER TABLE `campaign_dynamic_form` DISABLE KEYS */;
/*!40000 ALTER TABLE `campaign_dynamic_form` ENABLE KEYS */;
UNLOCK TABLES;




--
-- Table structure for table `campaign_entry`
--

DROP TABLE IF EXISTS `campaign_entry`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `campaign_entry` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `name` varchar(64) NOT NULL default '',
  `id_queue_call_entry` int(10) unsigned NOT NULL,
  `id_form` int(10) unsigned default NULL,
  `datetime_init` date NOT NULL,
  `datetime_end` date NOT NULL,
  `daytime_init` time NOT NULL,
  `daytime_end` time NOT NULL,
  `estatus` varchar(1) NOT NULL default 'A',
  `script` text NOT NULL,
  `id_url` int(10) unsigned default NULL,
  `id_team` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `id_queue_call_entry` (`id_queue_call_entry`),
  KEY `id_form` (`id_form`),
  KEY `id_url` (`id_url`),
  KEY `id_team` (`id_team`),
  CONSTRAINT `campaign_entry_ibfk_1` FOREIGN KEY (`id_queue_call_entry`) REFERENCES `queue_call_entry` (`id`),
  CONSTRAINT `campaign_entry_ibfk_2` FOREIGN KEY (`id_form`) REFERENCES `form` (`id`),
  CONSTRAINT `campaign_entry_ibfk_3` FOREIGN KEY (`id_url`) REFERENCES `campaign_external_url` (`id`),
  CONSTRAINT `campaign_entry_ibfk_4` FOREIGN KEY (`id_team`) REFERENCES `team` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `campaign_entry`
--

LOCK TABLES `campaign_entry` WRITE;
/*!40000 ALTER TABLE `campaign_entry` DISABLE KEYS */;
/*!40000 ALTER TABLE `campaign_entry` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `campaign_external_url`
--

DROP TABLE IF EXISTS `campaign_external_url`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `campaign_external_url` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `urltemplate` varchar(250) NOT NULL,
  `description` varchar(64) NOT NULL,
  `active` tinyint(1) NOT NULL default '1',
  `opentype` varchar(16) NOT NULL default 'window',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `campaign_external_url`
--

LOCK TABLES `campaign_external_url` WRITE;
/*!40000 ALTER TABLE `campaign_external_url` DISABLE KEYS */;
/*!40000 ALTER TABLE `campaign_external_url` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `campaign_form`
--

DROP TABLE IF EXISTS `campaign_form`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `campaign_form` (
  `id_campaign` int(10) unsigned NOT NULL,
  `id_form` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`id_campaign`,`id_form`),
  KEY `id_campaign` (`id_campaign`),
  KEY `id_form` (`id_form`),
  CONSTRAINT `campaign_form_ibfk_1` FOREIGN KEY (`id_campaign`) REFERENCES `campaign` (`id`),
  CONSTRAINT `campaign_form_ibfk_2` FOREIGN KEY (`id_form`) REFERENCES `form` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `campaign_form`
--

LOCK TABLES `campaign_form` WRITE;
/*!40000 ALTER TABLE `campaign_form` DISABLE KEYS */;
/*!40000 ALTER TABLE `campaign_form` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `campaign_form_entry`
--

DROP TABLE IF EXISTS `campaign_form_entry`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `campaign_form_entry` (
  `id_campaign` int(10) unsigned NOT NULL,
  `id_form` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`id_campaign`,`id_form`),
  KEY `id_campaign` (`id_campaign`),
  KEY `id_form` (`id_form`),
  CONSTRAINT `campaign_form_entry_ibfk_1` FOREIGN KEY (`id_campaign`) REFERENCES `campaign_entry` (`id`),
  CONSTRAINT `campaign_form_entry_ibfk_2` FOREIGN KEY (`id_form`) REFERENCES `form` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `campaign_form_entry`
--

LOCK TABLES `campaign_form_entry` WRITE;
/*!40000 ALTER TABLE `campaign_form_entry` DISABLE KEYS */;
/*!40000 ALTER TABLE `campaign_form_entry` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `contact`
--

DROP TABLE IF EXISTS `contact`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `contact` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `cedula_ruc` varchar(15) NOT NULL,
  `name` varchar(50) NOT NULL,
  `telefono` varchar(15) NOT NULL,
  `apellido` varchar(50) NOT NULL,
  `origen` varchar(4) default 'crm',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `contact`
--

LOCK TABLES `contact` WRITE;
/*!40000 ALTER TABLE `contact` DISABLE KEYS */;
/*!40000 ALTER TABLE `contact` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `current_call_entry`
--

DROP TABLE IF EXISTS `current_call_entry`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `current_call_entry` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `id_agent` int(10) unsigned NOT NULL,
  `id_queue_call_entry` int(10) unsigned NOT NULL,
  `id_call_entry` int(10) unsigned NOT NULL,
  `callerid` varchar(15) NOT NULL,
  `datetime_init` datetime NOT NULL,
  `uniqueid` varchar(32) default NULL,
  `ChannelClient` varchar(32) default NULL,
  `hold` enum('N','S') default 'N',
  PRIMARY KEY  (`id`),
  KEY `id_agent` (`id_agent`),
  KEY `id_queue_call_entry` (`id_queue_call_entry`),
  KEY `id_call_entry` (`id_call_entry`),
  CONSTRAINT `current_call_entry_ibfk_1` FOREIGN KEY (`id_agent`) REFERENCES `agent` (`id`),
  CONSTRAINT `current_call_entry_ibfk_2` FOREIGN KEY (`id_queue_call_entry`) REFERENCES `queue_call_entry` (`id`),
  CONSTRAINT `current_call_entry_ibfk_3` FOREIGN KEY (`id_call_entry`) REFERENCES `call_entry` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `current_call_entry`
--

LOCK TABLES `current_call_entry` WRITE;
/*!40000 ALTER TABLE `current_call_entry` DISABLE KEYS */;
/*!40000 ALTER TABLE `current_call_entry` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `current_calls`
--

DROP TABLE IF EXISTS `current_calls`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `current_calls` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `id_call` int(10) unsigned NOT NULL,
  `fecha_inicio` datetime NOT NULL,
  `uniqueid` varchar(32) default NULL,
  `queue` varchar(16) NOT NULL,
  `agentnum` varchar(16) NOT NULL,
  `event` varchar(32) NOT NULL,
  `Channel` varchar(32) NOT NULL default '',
  `ChannelClient` varchar(32) default NULL,
  `hold` enum('N','S') default 'N',
  PRIMARY KEY  (`id`),
  KEY `id_call` (`id_call`),
  CONSTRAINT `current_calls_ibfk_1` FOREIGN KEY (`id_call`) REFERENCES `calls` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `current_calls`
--

LOCK TABLES `current_calls` WRITE;
/*!40000 ALTER TABLE `current_calls` DISABLE KEYS */;
/*!40000 ALTER TABLE `current_calls` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `dont_call`
--

DROP TABLE IF EXISTS `dont_call`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `dont_call` (
  `id` int(11) NOT NULL auto_increment,
  `caller_id` varchar(15) NOT NULL,
  `date_income` datetime default NULL,
  `status` varchar(1) default NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=10 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `dont_call`
--

LOCK TABLES `dont_call` WRITE;
/*!40000 ALTER TABLE `dont_call` DISABLE KEYS */;
/*!40000 ALTER TABLE `dont_call` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `eccp_authorized_clients`
--

DROP TABLE IF EXISTS `eccp_authorized_clients`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `eccp_authorized_clients` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `username` varchar(64) NOT NULL,
  `md5_password` varchar(32) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `eccp_authorized_clients`
--

LOCK TABLES `eccp_authorized_clients` WRITE;
/*!40000 ALTER TABLE `eccp_authorized_clients` DISABLE KEYS */;
/*!40000 ALTER TABLE `eccp_authorized_clients` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `form`
--

DROP TABLE IF EXISTS `form`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `form` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `nombre` varchar(40) NOT NULL,
  `descripcion` varchar(150) NOT NULL,
  `estatus` varchar(1) NOT NULL default 'A',
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `form`
--

LOCK TABLES `form` WRITE;
/*!40000 ALTER TABLE `form` DISABLE KEYS */;
/*!40000 ALTER TABLE `form` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `form_data_recolected`
--

DROP TABLE IF EXISTS `form_data_recolected`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `form_data_recolected` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `id_calls` int(10) unsigned NOT NULL,
  `id_form_field` int(10) unsigned NOT NULL,
  `value` varchar(250) NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `id_form_field` (`id_form_field`),
  KEY `id_calls` (`id_calls`),
  CONSTRAINT `form_data_recolected_ibfk_1` FOREIGN KEY (`id_form_field`) REFERENCES `form_field` (`id`),
  CONSTRAINT `form_data_recolected_ibfk_2` FOREIGN KEY (`id_calls`) REFERENCES `calls` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `form_data_recolected`
--

LOCK TABLES `form_data_recolected` WRITE;
/*!40000 ALTER TABLE `form_data_recolected` DISABLE KEYS */;
/*!40000 ALTER TABLE `form_data_recolected` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `form_data_recolected_entry`
--

DROP TABLE IF EXISTS `form_data_recolected_entry`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `form_data_recolected_entry` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `id_call_entry` int(10) unsigned NOT NULL,
  `id_form_field` int(10) unsigned NOT NULL,
  `value` varchar(250) NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `id_call_entry` (`id_call_entry`),
  KEY `id_form_field` (`id_form_field`),
  CONSTRAINT `form_data_recolected_entry_ibfk_1` FOREIGN KEY (`id_call_entry`) REFERENCES `call_entry` (`id`),
  CONSTRAINT `form_data_recolected_entry_ibfk_2` FOREIGN KEY (`id_form_field`) REFERENCES `form_field` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `form_data_recolected_entry`
--

LOCK TABLES `form_data_recolected_entry` WRITE;
/*!40000 ALTER TABLE `form_data_recolected_entry` DISABLE KEYS */;
/*!40000 ALTER TABLE `form_data_recolected_entry` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `form_field`
--

DROP TABLE IF EXISTS `form_field`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `form_field` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `id_form` int(10) unsigned NOT NULL,
  `etiqueta` text NOT NULL,
  `value` text NOT NULL,
  `tipo` varchar(25) NOT NULL,
  `orden` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `id_form` (`id_form`),
  CONSTRAINT `form_field_ibfk_1` FOREIGN KEY (`id_form`) REFERENCES `form` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=6 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `form_field`
--

LOCK TABLES `form_field` WRITE;
/*!40000 ALTER TABLE `form_field` DISABLE KEYS */;
/*!40000 ALTER TABLE `form_field` ENABLE KEYS */;
UNLOCK TABLES;

DROP TABLE IF EXISTS `dynamic_form`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `dynamic_form` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `name` varchar(40) NOT NULL,
  `description` varchar(150) NOT NULL,
  `status` varchar(1) NOT NULL default 'A',
  `type` enum('public','private') default 'public',
  `id_team` int(10) unsigned default NULL,
  `creation_date` datetime default NULL,
  `created_by` varchar(50) default NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `name` (`name`),
  KEY `id_team` (`id_team`),
  CONSTRAINT `dynamic_form_ibfk_1` FOREIGN KEY (`id_team`) REFERENCES `team` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `dynamic_form_data_recolected`
--

DROP TABLE IF EXISTS `dynamic_form_data_recolected`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `dynamic_form_data_recolected` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `id_calls` int(10) unsigned NOT NULL,
  `id_dynamic_form_node_field` int(10) unsigned NOT NULL,
  `value` text NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `id_dynamic_form_node_field` (`id_dynamic_form_node_field`),
  KEY `id_calls` (`id_calls`),
  CONSTRAINT `form_dynamic_data_recolected_ibfk_1` FOREIGN KEY (`id_dynamic_form_node_field`) REFERENCES `dynamic_form_node_field` (`id`),
  CONSTRAINT `form_dynamic_data_recolected_ibfk_2` FOREIGN KEY (`id_calls`) REFERENCES `calls` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `dynamic_form_data_recolected_entry`
--

DROP TABLE IF EXISTS `dynamic_form_data_recolected_entry`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `dynamic_form_data_recolected_entry` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `id_call_entry` int(10) unsigned NOT NULL,
  `id_dynamic_form_node_field` int(10) unsigned NOT NULL,
  `value` text NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `id_dynamic_form_node_field` (`id_dynamic_form_node_field`),
  KEY `id_call_entry` (`id_call_entry`),
  CONSTRAINT `form_dynamic_data_recolected_entry_ibfk_1` FOREIGN KEY (`id_dynamic_form_node_field`) REFERENCES `dynamic_form_node_field` (`id`),
  CONSTRAINT `form_dynamic_data_recolected_entry_ibfk_2` FOREIGN KEY (`id_call_entry`) REFERENCES `call_entry` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8; 


--
-- Table structure for table `dynamic_form_node`
--

DROP TABLE IF EXISTS `dynamic_form_node`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `dynamic_form_node` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `id_dynamic_form` int(10) unsigned NOT NULL,
  `name` varchar(40) NOT NULL,
  `status` varchar(1) NOT NULL default 'A',
  PRIMARY KEY  (`id`),
  KEY `id_dynamic_form` (`id_dynamic_form`),
  CONSTRAINT `dynamic_form_node_ibfk_1` FOREIGN KEY (`id_dynamic_form`) REFERENCES `dynamic_form` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `dynamic_form_node_field`
--

DROP TABLE IF EXISTS `dynamic_form_node_field`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `dynamic_form_node_field` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `id_dynamic_form_node` int(10) unsigned NOT NULL,
  `description` varchar(255) default NULL,
  `type` varchar(10) NOT NULL,
  `status` varchar(1) NOT NULL default 'A',
  `recyclable` enum('yes','no') default 'no',
  PRIMARY KEY  (`id`),
  KEY `id_dynamic_form_node` (`id_dynamic_form_node`),
  CONSTRAINT `dynamic_form_node_field_ibfk_1` FOREIGN KEY (`id_dynamic_form_node`) REFERENCES `dynamic_form_node` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `dynamic_form_node_field_option`
--

DROP TABLE IF EXISTS `dynamic_form_node_field_option`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `dynamic_form_node_field_option` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `id_dynamic_form_node_field` int(10) unsigned NOT NULL,
  `description` varchar(40) NOT NULL,
  `destination_node` varchar(10) default NULL,
  `status` varchar(1) NOT NULL default 'A',
  PRIMARY KEY  (`id`), 
  UNIQUE KEY `id_dynamic_form_node_field_2` (`id_dynamic_form_node_field`,`description`),
  KEY `id_dynamic_form_node_field` (`id_dynamic_form_node_field`),
  CONSTRAINT `dynamic_form_node_field_option_ibfk_1` FOREIGN KEY (`id_dynamic_form_node_field`) REFERENCES `dynamic_form_node_field` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Table structure for table `queue_call_entry`
--

DROP TABLE IF EXISTS `queue_call_entry`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `queue_call_entry` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `queue` varchar(50) default NULL,
  `date_init` date default NULL,
  `time_init` time default NULL,
  `date_end` date default NULL,
  `time_end` time default NULL,
  `estatus` varchar(1) NOT NULL default 'A',
  `script` text,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `queue_call_entry`
--

LOCK TABLES `queue_call_entry` WRITE;
/*!40000 ALTER TABLE `queue_call_entry` DISABLE KEYS */;
/*!40000 ALTER TABLE `queue_call_entry` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `resource`
--

DROP TABLE IF EXISTS `resource`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `resource` (
  `resource_name` varchar(50) NOT NULL default '',
  `description` varchar(100) default NULL,
  PRIMARY KEY  (`resource_name`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `resource`
--

LOCK TABLES `resource` WRITE;
/*!40000 ALTER TABLE `resource` DISABLE KEYS */;

 INSERT INTO `resource` VALUES ('ccpro_agentoptions','Agent Options'),('ccpro_agents','Agents'),('ccpro_agent_console','Agent Console'),('ccpro_break_administrator','Breaks'),('ccpro_callcenter_config','Configuration'),('ccpro_calls_detail','Calls Detail\"'),('ccpro_calls_per_agent','Calls per Agent'),('ccpro_calls_per_hour','Calls per hour'),('ccpro_campaign_in','Ingoing Campaigns'),('ccpro_campaign_monitoring','Campaign monitoring'),('ccpro_campaign_out','Campaigns'),('ccpro_cb_extensions','Callback Extensions'),('ccpro_client','Clients'),('ccpro_dont_call_list','Do not Call List'),('ccpro_eccp_users','ECCP Users'),('ccpro_external_url','External URLs'),('ccpro_forms','Forms'),('ccpro_form_designer','Form Designer'),('ccpro_form_list','Form Preview'),('ccpro_graphic_calls','Graphic Calls per hour'),('ccpro_hold_time','Hold Time'),('ccpro_ingoings_calls_success','Ingoing Calls Success'),('ccpro_ingoing_calls','Ingoing Calls'),('ccpro_login_logout','Login Logout'),('ccpro_manager','Manager'),('ccpro_outgoing_calls','Outgoing Calls'),('ccpro_queues','Queues'),('ccpro_reports_break','Reports Break'),('ccpro_reports_ingoing_call','Reports'),('ccpro_rep_agents_monitoring','Agents Monitoring'),('ccpro_rep_agent_information','Agent Information'),('ccpro_rep_incoming_calls_monitoring','Incoming calls monitoring'),('ccpro_rep_trunks_used_per_hour','Trunks used per hour'),('ccpro_supervisor_account','Supervisor Account'),('ccpro_teams','Teams'),('ccpro_assign_agents','Assign Agents Queue'),('ccpro_dynamic_form_list','Dynamic Forms'),('ccpro_configuration','Configuration'),('ccpro_amd_config','AMD Config'),('ccpro_monitoring', 'Monitoring'), ('ccpro_campaign_recycle' , 'Campaign Recycle'), ('ccpro_supervisor_accounts','Supervisor Accounts');

/*!40000 ALTER TABLE `resource` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sp_team`
--

DROP TABLE IF EXISTS `sp_team`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `sp_team` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `id_supervisor` int(10) unsigned NOT NULL,
  `id_team` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `id_supervisor` (`id_supervisor`),
  KEY `id_team` (`id_team`),
  CONSTRAINT `sp_team_ibfk_1` FOREIGN KEY (`id_supervisor`) REFERENCES `supervisor` (`id`) ON DELETE CASCADE,
  CONSTRAINT `sp_team_ibfk_2` FOREIGN KEY (`id_team`) REFERENCES `team` (`id`) ON DELETE CASCADE
) ENGINE=InnoDB AUTO_INCREMENT=9 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sp_team`
--

LOCK TABLES `sp_team` WRITE;
/*!40000 ALTER TABLE `sp_team` DISABLE KEYS */;
/*!40000 ALTER TABLE `sp_team` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sp_type`
--

DROP TABLE IF EXISTS `sp_type`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `sp_type` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `name` varchar(100) NOT NULL,
  `description` varchar(200) NOT NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `sp_name` (`name`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sp_type`
--

LOCK TABLES `sp_type` WRITE;
/*!40000 ALTER TABLE `sp_type` DISABLE KEYS */;
INSERT INTO `sp_type` VALUES (1,'general_supervisor_callcenterpro','Call Center Pro General Supervisor'),(2,'team_supervisor_callcenterpro','Call Center Pro Team Supervisor');
/*!40000 ALTER TABLE `sp_type` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sp_type_resource`
--

DROP TABLE IF EXISTS `sp_type_resource`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `sp_type_resource` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `id_sp_type` int(10) unsigned NOT NULL,
  `id_resource` varchar(50) NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `id_sp_type` (`id_sp_type`),
  KEY `id_resource` (`id_resource`),
  CONSTRAINT `sp_type_resource_ibfk_1` FOREIGN KEY (`id_sp_type`) REFERENCES `sp_type` (`id`),
  CONSTRAINT `sp_type_resource_ibfk_2` FOREIGN KEY (`id_resource`) REFERENCES `resource` (`resource_name`)
) ENGINE=InnoDB AUTO_INCREMENT=63 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sp_type_resource`
--

LOCK TABLES `sp_type_resource` WRITE;
/*!40000 ALTER TABLE `sp_type_resource` DISABLE KEYS */;

INSERT INTO `sp_type_resource` VALUES (1,1,'ccpro_manager'),(2,1,'ccpro_supervisor_account'),(3,1,'ccpro_teams'),(4,2,'ccpro_outgoing_calls'),(5,2,'ccpro_campaign_out'),(6,2,'ccpro_dont_call_list'),(7,1,'ccpro_external_url'),(8,2,'ccpro_ingoing_calls'),(9,1,'ccpro_queues'),(11,2,'ccpro_campaign_in'),(12,2,'ccpro_agentoptions'),(13,1,'ccpro_agents'),(14,1,'ccpro_eccp_users'),(15,1,'ccpro_cb_extensions'),(16,2,'ccpro_break_administrator'),(17,2,'ccpro_forms'),(18,2,'ccpro_form_designer'),(19,2,'ccpro_form_list'),(20,2,'ccpro_reports_ingoing_call'),(21,2,'ccpro_reports_break'),(22,2,'ccpro_calls_detail'),(23,2,'ccpro_calls_per_hour'),(24,2,'ccpro_calls_per_agent'),(25,2,'ccpro_hold_time'),(26,2,'ccpro_login_logout'),(27,2,'ccpro_ingoings_calls_success'),(28,2,'ccpro_graphic_calls'),(29,2,'ccpro_rep_agent_information'),(30,2,'ccpro_rep_agents_monitoring'),(31,2,'ccpro_rep_trunks_used_per_hour'),(32,2,'ccpro_rep_incoming_calls_monitoring'),(33,2,'ccpro_campaign_monitoring'),(39,2,'ccpro_client'),(63,2,'ccpro_assign_agents'),(64,2,'ccpro_dynamic_form_list'),
(66,1,'ccpro_configuration'),(67,1,'ccpro_callcenter_config'),(68,1,'ccpro_amd_config'),(69,2,'ccpro_monitoring'),(70,2,'ccpro_campaign_recycle'),(71,1,'ccpro_outgoing_calls'),(72,1,'ccpro_campaign_out'),(73,1,'ccpro_dont_call_list'),(74,1,'ccpro_ingoing_calls'),(75,1,'ccpro_campaign_in'),(76,1,'ccpro_agentoptions'),(77,1,'ccpro_break_administrator'),(78,1,'ccpro_forms'),(79,1,'ccpro_form_designer'),(80,1,'ccpro_form_list'),(81,1,'ccpro_reports_ingoing_call'),(82,1,'ccpro_reports_break'),(83,1,'ccpro_calls_detail'),(84,1,'ccpro_calls_per_hour'),(85,1,'ccpro_calls_per_agent'),(86,1,'ccpro_hold_time'),(87,1,'ccpro_login_logout'),(88,1,'ccpro_ingoings_calls_success'),(89,1,'ccpro_graphic_calls'),(90,1,'ccpro_rep_agent_information'),(91,1,'ccpro_rep_agents_monitoring'),(92,1,'ccpro_rep_trunks_used_per_hour'),(93,1,'ccpro_rep_incoming_calls_monitoring'),(94,1,'ccpro_campaign_monitoring'),(95,1,'ccpro_client'),(96,1,'ccpro_assign_agents'),(97,1,'ccpro_dynamic_form_list'),(98,1,'ccpro_dynamic_form_designer'),(99,1,'ccpro_monitoring'),(100,1,'ccpro_campaign_recycle'),(101,1,'ccpro_supervisor_accounts');

/*!40000 ALTER TABLE `sp_type_resource` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `supervisor`
--

DROP TABLE IF EXISTS `supervisor`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `supervisor` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `username` varchar(20) NOT NULL,
  `name` varchar(50) NOT NULL,
  `md5_password` varchar(50) NOT NULL,
  `extension` varchar(10) default NULL,
  `id_type` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `sp_name` (`username`),
  KEY `id_type` (`id_type`),
  CONSTRAINT `supervisor_ibfk_1` FOREIGN KEY (`id_type`) REFERENCES `sp_type` (`id`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `supervisor`
--

LOCK TABLES `supervisor` WRITE;
/*!40000 ALTER TABLE `supervisor` DISABLE KEYS */;
/*!40000 ALTER TABLE `supervisor` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `team`
--

DROP TABLE IF EXISTS `team`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `team` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `name_team` varchar(100) NOT NULL,
  `description` text NOT NULL,
  `status` enum('1','0') default '1',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `team_name` (`name_team`)
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=utf8;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `team`
--

LOCK TABLES `team` WRITE;
/*!40000 ALTER TABLE `team` DISABLE KEYS */;
/*!40000 ALTER TABLE `team` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `valor_config`
--

DROP TABLE IF EXISTS `valor_config`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = utf8 */;
CREATE TABLE `valor_config` (
  `config_key` varchar(32) NOT NULL,
  `config_value` varchar(128) NOT NULL,
  `config_blob` blob,
  PRIMARY KEY  (`config_key`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `valor_config`
--

LOCK TABLES `valor_config` WRITE;
/*!40000 ALTER TABLE `valor_config` DISABLE KEYS */;
/*!40000 ALTER TABLE `valor_config` ENABLE KEYS */;
UNLOCK TABLES;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2014-01-29  5:19:41
