ALTER TABLE calls
ADD KEY `campaign_date_schedule` (`id_campaign`, `date_init`, `date_end`, `time_init`, `time_end`);

/* Tabla de bitácora de acciones tomadas por el agente de llamada manual */
CREATE TABLE IF NOT EXISTS manualdialing_action_log
(
    id                              INT(10) UNSIGNED    NOT NULL    AUTO_INCREMENT,
    datetime_action                 DATETIME            NOT NULL,
    id_agent                        INT(10) UNSIGNED    NOT NULL,
    operation                       ENUM(
        'view',         /* manualdialingsetlastviewedcontact */
        'dial',         /* manualdialingcall */
        'skip',         /* manualdialingskip */
        'reset',        /* manualdialingresetskip */
        'handled'       /* manualdialinghandled */
        ) NOT NULL,
    id_campaign                     INT(10) UNSIGNED    NOT NULL,
    id_contact                      INT(10) UNSIGNED,
    id_contact_number               INT(10) UNSIGNED,
    id_contact_number_callattempt   INT(10) UNSIGNED,

    PRIMARY KEY (id),
    FOREIGN KEY (id_agent) REFERENCES agent (id),
    FOREIGN KEY (id_campaign) REFERENCES manualdialing_campaign (id),
    FOREIGN KEY (id_contact) REFERENCES manualdialing_contact (id),
    FOREIGN KEY (id_contact_number) REFERENCES manualdialing_contact_number (id),
    FOREIGN KEY (id_contact_number_callattempt) REFERENCES manualdialing_contact_number_callattempt (id)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

ALTER TABLE audit
ADD COLUMN logout_reason ENUM('asteriskrestart', 'inactivitytimeout', 'agentlogoff', 'unregistered', 'loginmismatch'),
ADD COLUMN extension VARCHAR(64);

