var module_name = null;

// Variables de mensajes internacionalizados
var schedule_call_error_msg_missing_date = '';

/* El siguiente objeto es el estado de la interfaz del CallCenter. Al comparar
 * este objeto con los cambios de estado producto de eventos del ECCP, se
 * consigue detectar los cambios requeridos a la interfaz sin tener que recurrir
 * a llamadas repetidas al servidor.
 * Este objeto se inicializa en initialize_client_state() */
var estadoCliente =
{
	onhold:		false,	// VERDADERO si el sistema está en hold
	break_id:	null,	// Si != null, el ID del break en que está el agente
	calltype:	null,	// Si != null, tipo de llamada incoming/outgoing
	campaign_id:null,	// ID de la campaña a que pertenece la llamada atendida
	callid:		null,	// Si != null, ID de llamada que se está atendiendo

	// Por ahora sólo se modela si se espera o no una llamada manual
	waitingcall: false,

	// VERDADERO si se está en pausa de formulario
	formpause: false
};

// Agente logoneado en la consola
var console_agent = null;

// Cadena de unicidad del contacto para el cual se muestra URL
var ultimo_urlcontact = '';

/* Al cargar la página, o al recibir un evento AJAX, si timer_seconds tiene un
 * valor distinto de null, se inicia fechaInicio a la fecha y hora actual menos
 * el valor en segundos indicado por timer_seconds. En cualquier momento futuro,
 * el valor correcto del contador es la fecha actual menos la almacenada en
 * fechaInicio. */
var fechaInicio = null;
var timer = null;
var timer_sign = false;

// Objeto EventSource, si está soportado por el navegador
var evtSource = null;

// Copia del URL a cargar al agregar la nueva cejilla
var jqueryui_tabs_use_refresh = true;
var externalurl = null;
var externalurl_title = null;
var scheduled_label = null;


// Variables para listado de contactos
var tr_plantilla_contacto = null;
var tr_cargando_contacto = null;
var tr_sin_contacto = null;

// Variables para listado de reintentos
var tr_plantilla_reintento = null;
var tr_sin_reintento = null;

// Refresco de contactos pendiente hasta agentunlink
var refresh_manualcontacts_on_unlink = false;

$(document).ready(function() {
    module_name = getCurrentElastixModule();

    $('#elastix-callcenter-error-message').hide();
    $('#elastix-callcenter-info-message').hide();
    $('#elastix-callcenter-agendar-llamada-error-message').hide();

    $('#btn_hangup').button();
    $('#btn_togglebreak').button();
    $('#btn_transfer').button();
    $('#btn_manualpanel').button();
    $('#btn_vtigercrm').button();
    $('#btn_logout').button();
    $('#btn_confirmar_contacto').button();
    $('#btn_confirmar_contacto').click(do_confirm_contact);
    $('#btn_agendar_llamada').button();
    $('#schedule_same_agent').button();
    $('#schedule_radio').buttonset();
    $('#transfer_type_radio').buttonset();
    $('#btn_guardar_formularios').button();
    $('#btn_formpause_end').button();
    $('#schedule_date').hide();
    $('#elastix-callcenter-cejillas-contenido').tabs({
        // Este evento sólo se dispara para jQueryUI < 1.9.0
        add:    function (event, ui) {
            if (externalurl != null)
                $(ui.panel).append("<iframe scrolling=\"auto\" height=\"450\" frameborder=\"0\" width=\"100%\" src=\"" + externalurl + "\" />");
            externalurl = null;
        }
    });

    // Verificar versión de jQueryUI para manejo de tabs
    // map() sobre Array no existe en IE8
    //var curr_uiversion = $.ui.version.split('.').map(function(x) { return parseInt(x); });
    var curr_uiversion = [];
    var t_curr_uiversion = $.ui.version.split('.');
    for (var i = 0; i < t_curr_uiversion.length; i++) curr_uiversion[i] = parseInt(t_curr_uiversion[i]);
    var min_uiversion = [1,9,0];
    while (curr_uiversion.length > min_uiversion.length) min_uiversion.push(0);
    while (curr_uiversion.length < min_uiversion.length) curr_uiversion.push(0);
    while (curr_uiversion.length > 0) {
        var a = curr_uiversion.shift();
        var b = min_uiversion.shift();
        if (a > b) {
            jqueryui_tabs_use_refresh = true;
            break;
        }
        if (a < b) {
            jqueryui_tabs_use_refresh = false;
            break;
        }
    }

    if ($('#elastix-callcenter-llamada-paneles').length > 0) {
        $('#elastix-callcenter-contenido').layout({fxName: 'none', west: { size: 350, initClosed: true }});
        $('#elastix-callcenter-llamada-paneles').layout({fxName: 'none', west: { size: 300 }});
        $('#elastix-callcenter-llamada-paneles-izq').layout({fxName: 'none', south: { size: 250 }});
        $('#btn_manualpanel').click(function() { $('#elastix-callcenter-contenido').layout().toggle('west'); });

        // Botones para paginación de contactos
        $('#btn_contacts_seek_first').button({icons: {primary: 'ui-icon-seek-first'}, text: false});
        $('#btn_contacts_seek_prev').button({icons: {primary: 'ui-icon-seek-prev'}, text: false});
        $('#btn_contacts_seek_next').button({icons: {primary: 'ui-icon-seek-next'}, text: false});
        $('#btn_contacts_seek_last').button({icons: {primary: 'ui-icon-seek-end'}, text: false});

        $('#btn_contacts_seek_first, #btn_contacts_seek_prev, #btn_contacts_seek_next, #btn_contacts_seek_last')
            .button('disable');
        tr_cargando_contacto = $('div#elastix-callcenter-campanias-manuales-contactos > table > tbody > tr.tr_cargando_contacto').detach();
        tr_sin_contacto = $('div#elastix-callcenter-campanias-manuales-contactos > table > tbody > tr.tr_sin_contacto').detach();
        tr_plantilla_contacto = $('div#elastix-callcenter-campanias-manuales-contactos > table > tbody > tr').detach();
        $('div#elastix-callcenter-campanias-manuales-contactos > table > tbody').append(tr_sin_contacto);
        $('#manualdialing_campaign_id').change(function() {
            var campaign_id = $(this).val();
            var contactos_tbody = $('div#elastix-callcenter-campanias-manuales-contactos > table > tbody');

            // Anular valores previos
            contactos_tbody.data({
                auto_call_contact:  false,
                auto_call_contact:  false,
                urlopen_on_ring:    false,
                offset:             0,
                limit:              8,  // <-- sólo para campañas aleatorias
                total:              0
            });
            $('span#contacto_pagina_actual, span#contacto_pagina_total').text('0');

            // Se carga el diálogo y los formularios para la campaña manual
            $.get('index.php', {
                menu:       module_name,
                rawmode:    'yes',
                action:         'campaigninfo',
                campaign_type:  'manualdialing',
                campaign_id:    campaign_id
            }, function(respuesta) {
                verificar_error_session(respuesta);
                if (respuesta['action'] == 'error') {
                    mostrar_mensaje_error(respuesta['message']);
                    return;
                }
                $('#elastix-callcenter-llamada-script')
                    .empty()
                    .append(respuesta.llamada_script);
                $('#elastix-callcenter-llamada-form')
                    .empty()
                    .append(respuesta.llamada_formulario);

                // ATENCION: no hacer .data({hash}) porque puede hacer carrera
                // con do_cargar_campania_contactos que también asigna .data()
                // para llevar la pista de número de contactos
                contactos_tbody
                    .data('call_seek_behavior', respuesta.data.call_seek_behavior)
                    .data('auto_call_contact', respuesta.data.auto_call_contact)
                    .data('urlopen_on_ring', respuesta.data.urlopen_on_ring);
                if (respuesta.data.call_seek_behavior != 'random-seek') {
                    contactos_tbody.data('limit', 1);
                    $('tr#elastix-callcenter-campanias-manuales-contactos-navegacion').hide();
                } else {
                    $('tr#elastix-callcenter-campanias-manuales-contactos-navegacion').show();
                }
                apply_form_styles();

                do_cargar_campania_contactos(campaign_id, 0);
            });
        });
        $('#btn_contacts_seek_first').click(function() {
            do_cargar_campania_contactos($('#manualdialing_campaign_id').val(), 0);
        });
        $('#btn_contacts_seek_prev').click(function() {
            var contact_tbody = $('div#elastix-callcenter-campanias-manuales-contactos > table > tbody');
            var noffset = contact_tbody.data('offset') - contact_tbody.data('limit');
            if (noffset < 0) noffset = 0;
            do_cargar_campania_contactos($('#manualdialing_campaign_id').val(), noffset);
        });
        $('#btn_contacts_seek_next').click(function() {
            var contact_tbody = $('div#elastix-callcenter-campanias-manuales-contactos > table > tbody');
            var maxoffset = contact_tbody.data('total') - (contact_tbody.data('total') % contact_tbody.data('limit'));
            var noffset = contact_tbody.data('offset') + contact_tbody.data('limit');
            if (noffset > maxoffset) noffset = maxoffset;
            if (noffset < 0) noffset = 0;
            do_cargar_campania_contactos($('#manualdialing_campaign_id').val(), noffset);
        });
        $('#btn_contacts_seek_last').click(function() {
            var contact_tbody = $('div#elastix-callcenter-campanias-manuales-contactos > table > tbody');
            var maxoffset = contact_tbody.data('total') - (contact_tbody.data('total') % contact_tbody.data('limit'));
            if (maxoffset < 0) maxoffset = 0;
            do_cargar_campania_contactos($('#manualdialing_campaign_id').val(), maxoffset);
        });
        $('div#elastix-callcenter-campanias-manuales-contactos > table > tbody')
            .on('click', 'tr', function() {

            // Sólo atender cambio de contacto si consola está ociosa
            if (estadoCliente.waitingcall || estadoCliente.calltype != null)
                return;

            $(this).parent().children('tr').removeClass('contacto_seleccionado');

            // TODO: sólo aplicar contacto si no reservado o finalizado
            if ($(this).data('campaign_id') != null) {
                $(this).addClass('contacto_seleccionado');
                //console.debug($(this).data());
                do_cargar_contacto_info($(this).data('campaign_id'), $(this).data('contact_id'));
            }
        });
        tr_sin_reintento = $('#elastix-callcenter-campanias-manuales-callattempts > table > tbody > tr.tr_sin_intentos').detach();
        tr_plantilla_reintento = $('#elastix-callcenter-campanias-manuales-callattempts > table > tbody > tr').detach();
        $('#manualdialing_campaign_contact_number_id').change(function() {
            var data = $(this).children('option:selected').data();

            // Vaciar los controles
            var tbody_dialattempts = $('#elastix-callcenter-campanias-manuales-callattempts > table > tbody');
            tbody_dialattempts.empty();
            $('td#manualdialing_campaign_contact_number_daterange, td#manualdialing_campaign_contact_number_timerange, td#manualdialing_campaign_contact_number_source').text('(none)');

            if (data == undefined) return;

            // TODO: i18n
            $('td#manualdialing_campaign_contact_number_daterange').text((data.date_init != null)
                ? (data.date_init + ' - ' + data.date_end)
                : '(none)')
            $('td#manualdialing_campaign_contact_number_timerange').text((data.time_init != null)
                ? (data.time_init + ' - ' + data.time_end)
                : '(none)')
            $('td#manualdialing_campaign_contact_number_source').text((data.agent_create != null) ? data.agent_create : 'CSV');

            //console.debug(data.dialattempts);
            var llamada_en_progreso = false;
            if (data.dialattempts != undefined && !(data.dialattempts instanceof Array)) {
                for (var k in data.dialattempts) {
                    var tr = tr_plantilla_reintento.clone();
                    var da = data.dialattempts[k];

                    tr.data(da);
                    tr.children('td').first()
                        .text(da.datetime_originate_start)
                        .next()
                        .text(da.status)
                        .next()
                        .text((da.duration == null) ? '-' : da.duration)
                        .next()
                        .text((da.amd_status == null) ? '-' : da.amd_status)
                        .next()
                        .text((da.failure_cause == null) ? '-'  : da.failure_cause + ' - ' + da.failure_cause_txt)
                        .next();
                    tbody_dialattempts.append(tr);
                }
            } else {
                tbody_dialattempts.append(tr_sin_reintento);
            }
        });

        $('#btn_manual_marcar').click(function() {
            // Iniciar el marcado del contacto mostrado con el número indicado
            $.post('index.php', {
                menu:           module_name,
                rawmode:        'yes',
                action:         'manualcontactdial',
                campaign_id:    $('select#manualdialing_campaign_id').val(),
                contact_id:     $('div#elastix-callcenter-campanias-manuales-contactos > table > tbody > tr.contacto_seleccionado').data('contact_id'),
                dialnumber_id:  $('select#manualdialing_campaign_contact_number_id').val()
            }, function (respuesta) {
                verificar_error_session(respuesta);
                if (respuesta['action'] == 'error') {
                    mostrar_mensaje_error(respuesta['message']);
                    return;
                }


            })
            .fail(function() {
                mostrar_mensaje_error('Failed to connect to server to run request!');
            });
        });
        $('#btn_manual_saltar').click(function() {
            var contact_tr = $('div#elastix-callcenter-campanias-manuales-contactos > table > tbody > tr.contacto_seleccionado');
            if (contact_tr.length <= 0) {
                // TODO: i18n
                mostrar_mensaje_error('No contact selected to skip!');
                return;
            }

            // Saltarse el contacto indicado y pasar al siguiente
            $.post('index.php', {
                menu:           module_name,
                rawmode:        'yes',
                action:         'manualcontactskip',
                campaign_id:    $('select#manualdialing_campaign_id').val(),
                contact_id:     contact_tr.data('contact_id')
            }, function (respuesta) {
                verificar_error_session(respuesta);
                if (respuesta['action'] == 'error') {
                    mostrar_mensaje_error(respuesta['message']);
                    return;
                }

                contact_tr.data('skipped', true);
                contact_tr.find('span.saltado').show();

                recalcular_navegacion_manualdialing();
                if ($('div#elastix-callcenter-campanias-manuales-contactos > table > tbody').data('call_seek_behavior') != 'random-seek') {
                    // Recargar primer contacto marcable de la lista
                    do_cargar_campania_contactos($('#manualdialing_campaign_id').val(), 0);
                }
            })
            .fail(function() {
                mostrar_mensaje_error('Failed to connect to server to run request!');
            });

        });
        $('#btn_manual_reset').click(function() {
            // Resetear todos los contactos del agente a no saltados
            $.post('index.php', {
                menu:           module_name,
                rawmode:        'yes',
                action:         'manualcontactresetskip',
                campaign_id:    $('select#manualdialing_campaign_id').val()
            }, function (respuesta) {
                verificar_error_session(respuesta);
                if (respuesta['action'] == 'error') {
                    mostrar_mensaje_error(respuesta['message']);
                    return;
                }

                $('div#elastix-callcenter-campanias-manuales-contactos > table > tbody > tr').each(function (idx) {
                    $(this).data('skipped', false);
                    $(this).find('span.saltado').hide();
                });

                recalcular_navegacion_manualdialing();
                if ($('div#elastix-callcenter-campanias-manuales-contactos > table > tbody').data('call_seek_behavior') != 'random-seek') {
                    // Recargar primer contacto marcable de la lista
                    do_cargar_campania_contactos($('#manualdialing_campaign_id').val(), 0);
                }
            })
            .fail(function() {
                mostrar_mensaje_error('Failed to connect to server to run request!');
            });

        });
        $('#btn_manual_atendida').click(function() {
            // Marcar el contacto como ya atendido
            $.post('index.php', {
                menu:           module_name,
                rawmode:        'yes',
                action:         'manualcontacthandled',
                campaign_id:    $('select#manualdialing_campaign_id').val(),
                contact_id:     $('div#elastix-callcenter-campanias-manuales-contactos > table > tbody > tr.contacto_seleccionado').data('contact_id')
            }, function (respuesta) {
                verificar_error_session(respuesta);
                if (respuesta['action'] == 'error') {
                    mostrar_mensaje_error(respuesta['message']);
                    return;
                }

                // TODO: la llamada puede o no estar siendo atendida
            })
            .fail(function() {
                mostrar_mensaje_error('Failed to connect to server to run request!');
            });

        });
    }
    $('#btn_manual_marcar').button();
    $('#btn_manual_saltar').button();
    $('#btn_manual_reset').button();
    $('#btn_manual_atendida').button();

    // Al inicio de carga no hay campaña seleccionada
    $('#btn_manual_marcar, #btn_manual_saltar, #btn_manual_atendida').button('disable');

    // Operaciones que deben de repetirse al obtener formulario vía AJAX
    apply_form_styles();

    $('#submit_agent_login').click(do_login);
    $('#btn_logout').click(do_logout);
    $('#btn_hangup').click(do_hangup);

    // El siguiente código se ejecuta al hacer click en el botón de break
    $('#btn_togglebreak').click(function() {
    	if ($('#btn_togglebreak').hasClass('elastix-callcenter-boton-unbreak')) {
    		do_unbreak();
    	} else {
    		// Botón está en estado de elegir break
    		$('#elastix-callcenter-seleccion-break').dialog('open');
    	}
    });

    // El siguiente código se ejecuta al hacer click en el botón de formpause
    $('#btn_formpause_end').click(function() {
        $.post('index.php?menu=' + module_name + '&rawmode=yes', {
            menu:       module_name,
            rawmode:    'yes',
            action:     'unpauseform'
        },
        function (respuesta) {
            verificar_error_session(respuesta);
            if (respuesta['action'] == 'error') {
                mostrar_mensaje_error(respuesta['message']);
            }

            // El cambio de estado de la interfaz se delega a la revisión
            // periódica del estado del agente.
        }, 'json')
        .fail(function() {
            mostrar_mensaje_error('Failed to connect to server to run request!');
        });
    });

    // Botón para guardar formularios
    $('#btn_guardar_formularios').click(do_save_forms);

    $('#btn_transfer').click(function() {
		$('#elastix-callcenter-seleccion-transfer').dialog('open');
    });
    $('#btn_agendar_llamada').click(function() {
		$('#elastix-callcenter-agendar-llamada').dialog('open');
    });

    // El siguiente código se ejecuta al presionar el botón de VTiger
    $('#btn_vtigercrm').click(function() {
    	window.open("/vtigercrm/","vtigercrm");
    });

    var fechasAgenda = $('#schedule_date_start, #schedule_date_end').datepicker({
    	minDate:		0,
    	showOn:			'both',
    	buttonImage:	'images/calendar.gif',
    	buttonImageOnly: true,
    	showButtonPanel: true,
    	dateFormat:		'yy-mm-dd',
    	onSelect:		function (selectedDate) {
    		// Al seleccionar la fecha en un calendario, el otro se restringe
    		var option = (this.id == "schedule_date_start") ? "minDate" : "maxDate",
				instance = $( this ).data( "datepicker" ),
				date = $.datepicker.parseDate(
						instance.settings.dateFormat ||
						$.datepicker._defaults.dateFormat,
						selectedDate, instance.settings );
    		fechasAgenda.not( this ).datepicker( "option", option, date );
    	}
    });
    $('#schedule_type_campaign_end').change(function() {
    	$('#schedule_date').hide();
    });
    $('#schedule_type_bydate').change(function() {
    	$('#schedule_date').show();
    });

    // Configuración de controles de login
    $('div#input_callback').buttonset();
    $('input[name=input_callback]').change(function() {
        if ($(this).val() == 'static') {
            $('tr.credentials_dynamic').hide();
            $('tr.credentials_static').show();
        } else {
            $('tr.credentials_static').hide();
            $('tr.credentials_dynamic').show();
        }
    });
    $('input#input_callback_static').prop('checked', true);
    $('input#input_callback_static').change();
    $('div#input_callback').buttonset('refresh');
    $('#input_extension_callback, #input_extension, #input_agent_user').combobox();
});

$(window).unload(function() {
	if (evtSource != null) {
		evtSource.close();
		evtSource = null;
	}
});

function apply_form_styles()
{
    $('#elastix-callcenter-cejillas-formulario').tabs();
    $('.elastix-callcenter-field-date').datepicker({
    	showOn:			'both',
    	buttonImage:	'images/calendar.gif',
    	buttonImageOnly: true,
    	showButtonPanel: true,
    	changeMonth:	true,
    	changeYear:		true,
    	dateFormat:		'yy-mm-dd'
    });

    /* Al seleccionar un combo de ruta, se ocultan los fieldset de todas las
     * rutas referenciadas, y se muestra el fieldset de la ruta que ha sido
     * seleccionada. Si se elige la opción 0 ("Elija una opción"), todas las
     * rutas referenciadas quedan ocultas. Además de ocultar, se intercambia
     * la clase elastix-callcenter-field por elastix-callcenter-field-ignored
     * para que sólo los elementos de nodos visibles contribuyan a guardado. */
    $('#elastix-callcenter-cejillas-formulario select.elastix-callcenter-routefield').change(function(ev) {
        var dynform_fieldset_nodeprefix = 'fieldset#' + $(this).parents('div').first().attr('id')
            .replace("elastix-callcenter-formulario-dyn-", "dyn-node-") + '-';
        $(this).children('option').each(function(idx) {
            $(dynform_fieldset_nodeprefix + $(this).val()).hide();
            $(dynform_fieldset_nodeprefix + $(this).val() + ' .elastix-callcenter-field')
                .removeClass('elastix-callcenter-field')
                .addClass('elastix-callcenter-field-ignored');
        });

        // No mostrar fieldsets referenciados si este mismo route debe ignorarse
        if ($(this).hasClass('elastix-callcenter-field-ignored')) return;

        $(dynform_fieldset_nodeprefix + $(this).val()).show();
        $(dynform_fieldset_nodeprefix + $(this).val() + ' .elastix-callcenter-field-ignored')
            .removeClass('elastix-callcenter-field-ignored')
            .addClass('elastix-callcenter-field');

        // Si este route no debe ignorarse, debe propagarse change a routes
        // dentro de fieldsets referenciados. Esto asume que no hay ciclos.
        $(dynform_fieldset_nodeprefix + $(this).val() + ' select.elastix-callcenter-routefield').change();
    });

    // Ocultar todos los fieldset de formulario dinámico excepto el inicial
    $('#elastix-callcenter-cejillas-formulario > div > fieldset.elastix-callcenter-fieldset-dynnode').hide();
    $('#elastix-callcenter-cejillas-formulario > div > fieldset.elastix-callcenter-fieldset-dynnode .elastix-callcenter-field')
        .removeClass('elastix-callcenter-field')
        .addClass('elastix-callcenter-field-ignored');
    $('#elastix-callcenter-cejillas-formulario > div > fieldset.elastix-callcenter-fieldset-dynnode-initial').show();
    $('#elastix-callcenter-cejillas-formulario > div > fieldset.elastix-callcenter-fieldset-dynnode-initial .elastix-callcenter-field-ignored')
        .removeClass('elastix-callcenter-field-ignored')
        .addClass('elastix-callcenter-field');

    // Invocar el evento .change en todos los combos de ruta INICIAL
    $('#elastix-callcenter-cejillas-formulario fieldset.elastix-callcenter-fieldset-dynnode-initial select.elastix-callcenter-routefield')
        .change();
}

// Inicializar estado del cliente al refrescar la página
function initialize_client_state(nuevoEstado)
{
    console_agent = nuevoEstado.agent;
	estadoCliente.onhold = nuevoEstado.onhold;
	estadoCliente.break_id = nuevoEstado.break_id;
	estadoCliente.calltype = nuevoEstado.calltype;
	estadoCliente.campaign_id = nuevoEstado.campaign_id;
	estadoCliente.callid = nuevoEstado.callid;
	estadoCliente.waitingcall = nuevoEstado.waitingcall;
	estadoCliente.formpause = nuevoEstado.formpause;

	// Lanzar el callback que actualiza el estado de la llamada
    setTimeout(do_checkstatus, 1);

    iniciar_cronometro((nuevoEstado.timer_seconds !== '') ? nuevoEstado.timer_seconds : null);
    abrir_url_externo(nuevoEstado.urlopentype, nuevoEstado.url, nuevoEstado.urlcontact);
}

// Inicializar el cronómetro con el valor de segundos indicado
function iniciar_cronometro(timer_seconds)
{
	// Anular el estado anterior
	if (timer != null) {
		clearTimeout(timer);
		timer = null;
		timer_sign = false;
	}
	fechaInicio = null;
	$('#elastix-callcenter-cronometro').text('00:00:00');

	// Iniciar el estado nuevo, si es válido
	if (timer_seconds != null) {
		fechaInicio = new Date();
		timer_sign = (timer_seconds < 0);
		fechaInicio.setTime(fechaInicio.getTime() - timer_seconds * 1000);
		timer = setTimeout(actualizar_cronometro, 1);
	}
}

// Cada 500 ms se llama a esta función para actualizar el cronómetro
function actualizar_cronometro()
{
	var fechaDiff = new Date();
	var signed_msec = fechaDiff.getTime() - fechaInicio.getTime();
	var msec = Math.abs(signed_msec);
	var tiempo = [0, 0, 0];
	tiempo[0] = (msec - (msec % 1000)) / 1000;
	tiempo[1] = (tiempo[0] - (tiempo[0] % 60)) / 60;
	tiempo[0] %= 60;
	tiempo[2] = (tiempo[1] - (tiempo[1] % 60)) / 60;
	tiempo[1] %= 60;
	var i = 0;
	for (i = 0; i < 3; i++) { if (tiempo[i] <= 9) tiempo[i] = "0" + tiempo[i]; }
	$('#elastix-callcenter-cronometro').text(tiempo[2] + ':' + tiempo[1] + ':' + tiempo[0]);

	// Instalar timeout sólo si signed_msec NO cambió de signo
	if (timer_sign && signed_msec > 0) {
	    timer_sign = false;
	} else {
	    timer = setTimeout(actualizar_cronometro, 500);
	}
}

// El siguiente código aplica estilos de jQueryUI
function apply_ui_styles(uidata)
{
    if (uidata.no_call) {
        $('#btn_hangup').button('disable');
        $('#btn_transfer').button('disable');

        /* Esta llamada generalmente se realiza cuando el agente recién carga
         * la consola y no ha recibido una llamada todavía. Se debe de modificar
         * si se requiere que el agente recargue frecuentemente la consola y
         * preserve el hecho de que atendió previamente una llamada en la misma
         * sesión. */
        $('#btn_agendar_llamada').button('disable');
    }
    if (!uidata.can_confirm_contact) {
    	$('#btn_confirmar_contacto').button('disable');
    }
    if (!uidata.can_save_formdata) {
        $('#btn_guardar_formularios').button('disable');
    }
    if (!uidata.formpause) {
        $('#btn_formpause_end').button('disable');
    }
    schedule_call_error_msg_missing_date = uidata.schedule_call_error_msg_missing_date;
    $('#elastix-callcenter-seleccion-break').dialog({
        autoOpen: false,
        width: 300,
        height: 150,
        modal: true,
        buttons: [
            {
                text: uidata['break_commit'],
                click: function() { do_break(); $(this).dialog('close'); }
            },
            {
                text: uidata['break_dismiss'],
                click: function() { $(this).dialog('close'); }
            }
        ]
    });
    $('#elastix-callcenter-seleccion-transfer').dialog({
        autoOpen: false,
        width: 400,
        height: 200,
        modal: true,
        buttons: [
            {
                text: uidata['transfer_commit'],
                click: function() { do_transfer(); $(this).dialog('close'); }
            },
            {
                text: uidata['transfer_dismiss'],
                click: function() { $(this).dialog('close'); }
            }
        ]
    });
    $('#elastix-callcenter-agendar-llamada').dialog({
        autoOpen: false,
        width: 700,
        height: 350,
        modal: true,
        buttons: [
            {
                text: uidata['schedule_commit'],
                click: function() { if (do_schedule()) { $(this).dialog('close'); }}
            },
            {
                text: uidata['schedule_dismiss'],
                click: function() { $(this).dialog('close'); }
            }
        ]
    });

    externalurl_title = uidata['external_url_tab'];
    scheduled_label = uidata['scheduled'];
}

// Redireccionar la página entera en caso de que la sesión se haya perdido
function verificar_error_session(respuesta)
{
	if (respuesta['statusResponse'] == 'ERROR_SESSION') {
		if (respuesta['error'] != null && respuesta['error'] != '')
			alert(respuesta['error']);
		window.open('index.php', '_self');
	}
}

// El siguiente código se ejecutará cuando se presione el botón de login del agente
function do_login()
{
    $.post('index.php?menu=' + module_name + '&rawmode=yes', {
        menu:           module_name,
        rawmode:        'yes',
        action:         'doLogin',
        agent:          $('#input_agent_user').val(),
        ext:            $('#input_extension').val(),
        ext_callback:   $('#input_extension_callback').val(),
        pass_callback:  $('#input_password_callback').val(),
        callback:       $('input#input_callback_dynamic').is(':checked')
    },
    function(respuesta) {
        verificar_error_session(respuesta);
        if (respuesta['status']) {
            // Se inicia la espera del login del agente
            login_estado_espera(respuesta['message']);
            setTimeout('do_checklogin()', 1);
        } else {
            // Ha ocurrido un error
            login_estado_error(respuesta['message']);
        }
    }, 'json')
    .fail(function() {
        login_estado_error('Failed to connect to server for agent login!');
    });
}

// El siguiente código se ejecuta al presionar el botón de colgado
function do_hangup()
{
	$('#btn_hangup').button('disable');
	$.post('index.php?menu=' + module_name + '&rawmode=yes', {
		menu:		module_name,
		rawmode:	'yes',
		action:		'hangup'
	},
	function (respuesta) {
		verificar_error_session(respuesta);
        if (respuesta['action'] == 'error') {
        	mostrar_mensaje_error(respuesta['message']);
        	if (estadoCliente.campaign_id != null || estadoCliente.waitingcall)
                $('#btn_hangup').button('enable');
        }

        // El cambio de estado de la interfaz se delega a la revisión
        // periódica del estado del agente.
	}, 'json')
	.fail(function() {
		mostrar_mensaje_error('Failed to connect to server to run request!');
	});
}

// Función que verifica si se ha completado el proceso de login
function do_checklogin()
{
	$.post('index.php?menu=' + module_name + '&rawmode=yes', {
			menu:		module_name,
			rawmode:	'yes',
			action:		'checkLogin'
		},
		function (respuesta) {
			verificar_error_session(respuesta);
	        if (respuesta['action'] == 'error') {
	            // El login ha concluido con un error
	            login_estado_error(respuesta['message']);
	        }
	        if (respuesta['action'] == 'wait') {
	            // Todavía no se termina proceso login, se espera
	            setTimeout('do_checklogin()', 1);
	        }
	        if (respuesta['action'] == 'login') {
	            // Login de agente ha tenido éxito, se refresca para mostrar formulario
	            window.open('index.php?menu=' + module_name, "_self");
	        }
    	}, 'json')
    	.fail(function() {
    		login_estado_error('Failed to connect to server to check for agent login!');
    	});
}

// El siguiente código se ejecuta al presionar el botón de fin de sesión
function do_logout()
{
    $.post('index.php?menu=' + module_name + '&rawmode=yes', {
		menu:		module_name,
		rawmode:	'yes',
		action:		'agentLogout'
	},
	function (respuesta) {
		verificar_error_session(respuesta);
        if (respuesta['action'] == 'error') {
        	mostrar_mensaje_error(respuesta['message']);
        }

        // Se asume que a pesar del error, el agente está deslogoneado
        window.open('index.php?menu=' + module_name, "_self");
	}, 'json')
	.fail(function() {
		mostrar_mensaje_error('Failed to connect to server to run request!');
	});
}

// Cambiar el mensaje de login al estado de espera
function login_estado_espera(msg)
{
    $('#login_icono_espera').attr("style", "visibility: visible; position: none;");
    $('#login_fila_estado').attr("style", "visibility: visible; position: none;");
    $('#login_msg_espera').text(msg);
    $('#login_msg_error').text("");
}

// Cambiar el mensaje de login al estado de error
function login_estado_error(msg)
{
    $('#login_icono_espera').attr("style", "visibility: hidden; position: absolute;");
    $('#login_fila_estado').attr("style", "visibility: visible; position: none;");
    $('#login_msg_espera').text("");
    $('#login_msg_error').text(msg);
}

// Cambiar el mensaje de login al estado ocioso
function login_estado_ocioso()
{
    $('#login_icono_espera').attr("style", "visibility: hidden; position: absolute;");
    $('#login_fila_estado').attr("style", "visibility: hidden; position: absolute;");
    $('#login_msg_espera').text("");
    $('#login_msg_error').text("");
}

function do_break()
{
	$.post('index.php?menu=' + module_name + '&rawmode=yes', {
		menu:		module_name,
		rawmode:	'yes',
		action:		'break',
		breakid:	$('#break_select').val()
	},
	function (respuesta) {
		verificar_error_session(respuesta);
        if (respuesta['action'] == 'error') {
        	mostrar_mensaje_error(respuesta['message']);
        }

        // El cambio de estado de la interfaz se delega a la revisión
        // periódica del estado del agente.
        // TODO: definir evento agentbreakenter y agentbreakexit
	}, 'json')
	.fail(function() {
		mostrar_mensaje_error('Failed to connect to server to run request!');
	});
}

function do_unbreak()
{
	// Botón está en estado de quitar break
    $.post('index.php?menu=' + module_name + '&rawmode=yes', {
		menu:		module_name,
		rawmode:	'yes',
		action:		'unbreak'
	},
	function (respuesta) {
		verificar_error_session(respuesta);
        if (respuesta['action'] == 'error') {
        	mostrar_mensaje_error(respuesta['message']);
        }

        // El cambio de estado de la interfaz se delega a la revisión
        // periódica del estado del agente.
        // TODO: definir evento agentbreakenter y agentbreakexit
	}, 'json')
	.fail(function() {
		mostrar_mensaje_error('Failed to connect to server to run request!');
	});
}

function do_transfer()
{
	$.post('index.php?menu=' + module_name + '&rawmode=yes', {
		menu:		module_name,
		rawmode:	'yes',
		action:		'transfer',
		extension:	$('#transfer_extension').val(),
		atxfer: 	$('#transfer_type_attended').is(':checked')
	},
	function (respuesta) {
		verificar_error_session(respuesta);
        if (respuesta['action'] == 'error') {
        	mostrar_mensaje_error(respuesta['message']);
        }

        // El cambio de estado de la interfaz se delega a la revisión
        // periódica del estado del agente.
	}, 'json')
	.fail(function() {
		mostrar_mensaje_error('Failed to connect to server to run request!');
	});
}

function do_confirm_contact()
{
	$.post('index.php?menu=' + module_name + '&rawmode=yes', {
		menu:		module_name,
		rawmode:	'yes',
		action:		'confirm_contact',
		id_contact:	$('#llamada_entrante_contacto_id').val()
	},
	function (respuesta) {
		verificar_error_session(respuesta);
        if (respuesta['action'] == 'error') {
        	mostrar_mensaje_error(respuesta['message']);
        } else {
        	mostrar_mensaje_info(respuesta['message']);
        }

	}, 'json')
	.fail(function() {
		mostrar_mensaje_error('Failed to connect to server to run request!');
	});
}

function do_schedule()
{
	// Verificar que se ha elegido realmente una fecha
	if ($('#schedule_type_bydate').is(':checked') &&
		($('#schedule_date_start').datepicker('getDate') == null || $('#schedule_date_end').datepicker('getDate') == null )) {

		$('#elastix-callcenter-agendar-llamada-error-message-text').text(schedule_call_error_msg_missing_date);
		$('#elastix-callcenter-agendar-llamada-error-message').show('slow', 'linear', function() {
			setTimeout(function() {
				$('#elastix-callcenter-agendar-llamada-error-message').fadeOut();
			}, 5000);
		});
		return false;
	}
	$.post('index.php?menu=' + module_name + '&rawmode=yes', {
		menu:		module_name,
		rawmode:	'yes',
		action:		'schedule',
		data:		{
			schedule_new_phone:		$('#schedule_new_phone').val(),
			schedule_new_name:		$('#schedule_new_name').val(),
			schedule_use_daterange:	$('#schedule_type_bydate').is(':checked'),
			schedule_use_sameagent:	$('#schedule_same_agent').is(':checked'),
			schedule_date_start:	$('#schedule_date_start').val(),	// Asume yyyy-mm-dd
			schedule_date_end:		$('#schedule_date_end').val(),		// Asume yyyy-mm-dd
			schedule_time_start:	$('#schedule_time_start_hh').val() + ':' + $('#schedule_time_start_mm').val() + ':00',
			schedule_time_end:		$('#schedule_time_end_hh').val() + ':' + $('#schedule_time_end_mm').val() + ':59'
		}
	},
	function (respuesta) {
		verificar_error_session(respuesta);
        if (respuesta['action'] == 'error') {
        	mostrar_mensaje_error(respuesta['message']);
        } else {
        	mostrar_mensaje_info(respuesta['message']);
        }

	}, 'json')
	.fail(function() {
		mostrar_mensaje_error('Failed to connect to server to run request!');
	});
	return true;
}

function do_save_forms()
{
	$.post('index.php?menu=' + module_name + '&rawmode=yes', {
		menu:		module_name,
		rawmode:	'yes',
		action:		'saveforms',
		data:		$('.elastix-callcenter-field').map(function() {
						return [[this.id, $(this).val()]];
					}).get()
	},
	function (respuesta) {
		verificar_error_session(respuesta);
        if (respuesta['action'] == 'error') {
        	mostrar_mensaje_error(respuesta['message']);
        } else {
        	mostrar_mensaje_info(respuesta['message']);
        }

	}, 'json')
	.fail(function() {
		mostrar_mensaje_error('Failed to connect to server to run request!');
	});
}

function do_ping()
{
	$.get('index.php', {menu: module_name, action: 'ping', rawmode: 'yes'}, function (respuesta) {
		verificar_error_session(respuesta);
		setTimeout(do_ping, (respuesta['gc_maxlifetime'] / 2) * 1000);
	});
}

function do_checkstatus()
{
	params = {
		menu:		module_name,
		rawmode:	'yes',
		action:		'checkStatus',
		clientstate: estadoCliente
	};
	if (window.EventSource) {
		params['serverevents'] = true;
		evtSource = new EventSource('index.php?' + $.param(params));
		evtSource.onmessage = function(event) {
			manejarRespuestaStatus($.parseJSON(event.data));
		}
		evtSource.onerror = function(event) {
			mostrar_mensaje_error('Lost connection to server (SSE), retrying...');
		}

		// Iniciar el ping de inmediato
		setTimeout(do_ping, 1);
	} else {
		$.post('index.php?menu=' + module_name + '&rawmode=yes', params,
		function (respuesta) {
			verificar_error_session(respuesta);
			manejarRespuestaStatus(respuesta);

			// Lanzar el método de inmediato
			setTimeout(do_checkstatus, 1);
		}, 'json').fail(function() {
			mostrar_mensaje_error('Lost connection to server (Long-Polling), retrying...');
			setTimeout(do_checkstatus, 5000);
		});
	}
}

function manejarRespuestaStatus(respuesta)
{
	for (var i in respuesta) {
		if (respuesta[i].txt_estado_agente_inicial != null)
			$('#elastix-callcenter-estado-agente-texto').text(respuesta[i].txt_estado_agente_inicial);
		if (respuesta[i].class_estado_agente_inicial != null)
			$('#elastix-callcenter-estado-agente')
				.removeClass('elastix-callcenter-class-estado-ocioso')
				.removeClass('elastix-callcenter-class-estado-break')
				.removeClass('elastix-callcenter-class-estado-activo')
				.removeClass('elastix-callcenter-class-estado-esperando')
				.removeClass('elastix-callcenter-class-estado-formpause')
				.addClass(respuesta[i].class_estado_agente_inicial);
		if (respuesta[i].timer_seconds != null) {
			if (respuesta[i].timer_seconds !== '') {
				iniciar_cronometro(respuesta[i].timer_seconds);
			} else {
				iniciar_cronometro(null);
			}
		}

		switch (respuesta[i].event) {
		case 'logged-out':
			// El refresco debería conducir a la página de login
			window.open('index.php?menu=' + module_name, "_self");
			return;
		case 'breakenter':
			// El agente ha entrado en break
			estadoCliente.break_id = respuesta[i].break_id;
			$('#btn_togglebreak')
				.removeClass('elastix-callcenter-boton-break')
				.addClass('elastix-callcenter-boton-unbreak')
				.children('span').text(respuesta[i].txt_btn_break);
			break;
		case 'breakexit':
			// El agente ha salido del break
			estadoCliente.break_id = null;
			$('#btn_togglebreak')
				.removeClass('elastix-callcenter-boton-unbreak')
				.addClass('elastix-callcenter-boton-break')
				.children('span').text(respuesta[i].txt_btn_break);
			break;
		case 'holdenter':
			estadoCliente.onhold = true;
			// TODO
			break;
		case 'holdexit':
			estadoCliente.onhold = false;
			// TODO
			break;
		case 'formpauseenter':
		    // El agente entra en pausa de formulario
		    estadoCliente.formpause = true;
		    $('#btn_formpause_end').button('enable');
		    break;
		case 'formpauseexit':
		    // El agente sale de pausa de formulario
		    estadoCliente.formpause = false;
		    $('#btn_formpause_end').button('disable');
		    break;
		case 'agentlinked':
			// El agente ha recibido una llamada
			estadoCliente.calltype = respuesta[i].calltype;
			estadoCliente.campaign_id = respuesta[i].campaign_id;
			estadoCliente.callid = respuesta[i].callid;
			$('#btn_transfer').button('enable');
			$('#elastix-callcenter-cronometro').text(respuesta[i].cronometro);
			$('#elastix-callcenter-llamada-info')
			    .css('color', '')
				.empty()
				.append(respuesta[i].llamada_informacion);
			$('#elastix-callcenter-llamada-script')
				.empty()
				.append(respuesta[i].llamada_script);
			$('#elastix-callcenter-llamada-form')
				.empty()
				.append(respuesta[i].llamada_formulario);
			$('#llamada_entrante_contacto_telefono, #llamada_saliente_contacto_telefono')
				.text(respuesta[i].txt_contacto_telefono);
			$('#schedule_new_phone').val(respuesta[i].txt_contacto_telefono);

			// Preparar y mostrar la barra correspondiente
			if (respuesta[i].calltype == 'incoming') {
				$('#btn_confirmar_contacto').button();
				if (respuesta[i].puede_confirmar_contacto)
					$('#btn_confirmar_contacto').button('enable');
				else $('#btn_confirmar_contacto').button('disable');
				$('#btn_confirmar_contacto').click(do_confirm_contact);
			} else if (respuesta[i].calltype == 'outgoing' || respuesta[i].calltype == 'manualdialing') {
				$('#llamada_saliente_nombres').text(respuesta[i].txt_contacto_nombres);
				$('#schedule_new_name').val(respuesta[i].txt_contacto_nombres);
				$('#btn_agendar_llamada').button('enable');
			}

			apply_form_styles();
		    $('#btn_guardar_formularios').button('enable');
		    $('#btn_manual_marcar, #btn_manual_saltar, #btn_manual_reset').button('disable');
		    recalcular_navegacion_manualdialing();
			abrir_url_externo(respuesta[i].urlopentype, respuesta[i].url, respuesta[i].urlcontact);
			break;
		case 'agentunlinked':
	        // El agente se ha desconectado de la llamada
		    var l_calltype = estadoCliente.calltype;
		    var l_campaign_id = estadoCliente.campaign_id;
			estadoCliente.calltype = null;
			estadoCliente.campaign_id = null;
			estadoCliente.callid = null;

	        $('#btn_transfer').button('disable');
	        if (l_calltype == 'incoming') {
	            $('#btn_agendar_llamada').button('disable');
	        }
	        $('#elastix-callcenter-cronometro').text('00:00:00');

	        // Vaciar las áreas para la llamada
			$('#elastix-callcenter-llamada-script').empty();
			$('#elastix-callcenter-llamada-info').css("color", "#778899");

			$('#btn_manual_marcar, #btn_manual_saltar, #btn_manual_reset').button('enable');
			recalcular_navegacion_manualdialing();

			if (refresh_manualcontacts_on_unlink) {
			    refresh_manualcontacts_on_unlink = false;
			    if (l_calltype == 'manualdialing') {
			        // Esto asume que la llamada que se dejó de atender fue la finalizada
			        do_cargar_campania_contactos(l_campaign_id, 0);
			    }
			}
			break;
		case 'manualcontactstate':
		    var contact_tbody = $("div#elastix-callcenter-campanias-manuales-contactos > table > tbody");
		    contact_tbody.children('tr').each(function() {
		        if ($(this).data('campaign_id') == respuesta[i].campaign_id &&
		            $(this).data('contact_id') == respuesta[i].contact_id) {

		            // Actualizar estado del contacto con el mensaje
		            $(this).data('processing_status', respuesta[i].new_status);
		            $(this).data('reservation_agent', ((respuesta[i].new_status == 'pending') ? null : respuesta[i].agent_number));
		            $(this).data('reservation_datetime', ((respuesta[i].new_status == 'pending') ? null : respuesta[i].datetime));

		            var span_finalizado = $(this).find('span.finalizado');
		            var span_reservado = $(this).find('span.reservado');
		            switch (respuesta[i].new_status) {
		            case 'pending':
		                span_reservado.hide();
		                span_finalizado.hide();
		                break;
		            case 'reserved':
		                span_reservado.show();
		                span_finalizado.hide();
		                break;
		            case 'finished':
		                span_reservado.hide();
		                span_finalizado.show();
		                break;
		            }

		            /* Cambio de estado de contacto para el único contacto mostrado
		             * en una campaña no aleatoria. */
		            if (contact_tbody.data('call_seek_behavior') != 'random-seek' &&
		                $(this).hasClass('contacto_seleccionado')) {

		                /* Si el estado nuevo es reservado, y no ha sido reservado
		                 * por este agente, entonces ya no es marcable y se debe
		                 * refrescar para obtener la siguiente llamada marcable. */
		                if ($(this).data('processing_status') == 'reserved' &&
		                    $(this).data('reservation_agent') != console_agent) {
		                    do_cargar_campania_contactos($(this).data('campaign_id'), 0);

		                /* Si el estado nuevo es finalizado, sólo se debe refrescar
		                 * para nuevo contacto si la consola está ociosa. Si está
		                 * ocupada, se retrasa el refresco hasta recibir el evento
		                 * agentunlinked.
		                 * TODO: esto puede causar problemas si el agente está
		                 * llenando formularios con el contacto actual. */
		                } else if ($(this).data('processing_status') == 'finished') {
		                    if (estadoCliente.calltype == 'manualdialing') {
		                        // Esto asume que la llamada atendida es la misma que el contacto
		                        refresh_manualcontacts_on_unlink = true;
		                    } else {
		                        // Refrescar de inmediato
		                        do_cargar_campania_contactos($(this).data('campaign_id'), 0);
		                    }
		                }
		            }
		        }
		    });
		    recalcular_navegacion_manualdialing();
		    break;
		case 'manualcontactclaimed':
            var contact_tbody = $("div#elastix-callcenter-campanias-manuales-contactos > table > tbody");
            contact_tbody.children('tr').each(function() {
                if ($(this).data('campaign_id') == respuesta[i].campaign_id &&
                    $(this).data('contact_id') == respuesta[i].contact_id) {

                    if (respuesta[i].agent_number == console_agent) {
                        $(this).data('dedicated', true);
                    }

                    /* Cambio de estado de contacto para el único contacto mostrado
                     * en una campaña no aleatoria. */
                    if (contact_tbody.data('call_seek_behavior') != 'random-seek' &&
                        $(this).hasClass('contacto_seleccionado')) {

                        /* Si el contacto ha sido reclamado por otro agente,
                         * entonces ya no es marcable y se debe refrescar para
                         * obtener la siguiente llamada marcable. En teoría esto
                         * es redundante porque toda llamada reclamada también
                         * se reserva y la reservación también refresca. */
                        if (respuesta[i].agent_number != console_agent) {
                            do_cargar_campania_contactos($(this).data('campaign_id'), 0);
                        }
                    } else {
                        // TODO: este caso no debería ocurrir.
                    }
                }
            });
            recalcular_navegacion_manualdialing();
		    break;
		case 'waitingenter':
		    estadoCliente.waitingcall = true;
		    recalcular_navegacion_manualdialing();
		    abrir_url_externo(respuesta[i].urlopentype, respuesta[i].url, respuesta[i].urlcontact);
		    break;
		case 'waitingexit':
		    estadoCliente.waitingcall = false;
		    recalcular_navegacion_manualdialing();
		    break;
		case 'manualdialingprogress':
		    /* Plan:
		     * - mensaje contiene campaign_id, contact_id, number_id
		     * - ignorar a menos que campaign_id y contact_id coincidan con
		     *   lo mostrado en interfaz
		     * - dropdown de números tiene data para cada number_id del contacto
		     * - localizar <option> correspondiente al number_id recibido
		     * - localizar intento de marcado en dialattempts
		     * - agregar o actualizar dialattempts con valores recibidos
		     * - si number_id recibido coincide con el elegido en select de num,
		     *   invocar .change() sobre select de num
		     * TODO: no todos los campos de dialattempt se reciben a través
		     * de manualdialingprogress, puede ser necesario expandir en dialer
		     */
		    if ($('select#manualdialing_campaign_id').val() != respuesta[i].campaign_id)
		        break;

		    /* Colorear los contactos que se estén marcando de morado y los
		     * conectados de verde. Otros estados se quedan en blanco. */
		    $('div#elastix-callcenter-campanias-manuales-contactos > table > tbody > tr').each(function(idx) {
		        if ($(this).data('campaign_id') != respuesta[i].campaign_id) return;
		        if ($(this).data('contact_id') != respuesta[i].contact_id) return;

		        $(this).children('td')
		            .removeClass('elastix-callcenter-class-estado-esperando')
		            .removeClass('elastix-callcenter-class-estado-activo');
		        if (respuesta[i].new_status == 'Success')
		            $(this).children('td').addClass('elastix-callcenter-class-estado-activo');
		        if (respuesta[i].new_status == 'Placing' ||
		            respuesta[i].new_status == 'Dialing' ||
		            respuesta[i].new_status == 'Ringing')
		            $(this).children('td').addClass('elastix-callcenter-class-estado-esperando');
		    });

		    var tr_contacto = $('div#elastix-callcenter-campanias-manuales-contactos > table > tbody > tr.contacto_seleccionado');
		    if (tr_contacto.data('campaign_id') != respuesta[i].campaign_id)
		        break;
		    if (tr_contacto.data('contact_id') != respuesta[i].contact_id)
		        break;

		    // Localizar <option> en lista desplegable
		    var select_numberid = $('select#manualdialing_campaign_contact_number_id');
		    var option_numberid = select_numberid.children().filter(function(idx) {
		        return ($(this).data('id') == respuesta[i].number_id);
		    });
		    if (option_numberid.length < 1) break;
		    var number_dialattempts = option_numberid.data('dialattempts');

		    var call_id = respuesta[i].call_id;
		    if (number_dialattempts[call_id] == undefined) {
		        // Intento nuevo de marcado
		        number_dialattempts[call_id] = {
		            agent: ((undefined == respuesta[i].agent_number)
	                    ? null : respuesta[i].agent_number),
		            id: call_id,
		            onhold: false,
		            duration: ((undefined == respuesta[i].duration)
		                ? null : respuesta[i].duration),
		            failure_cause: ((undefined == respuesta[i].failure_cause)
		                ? null : respuesta[i].failure_cause),
		            failure_cause_txt: ((undefined == respuesta[i].failure_cause_txt)
		                ? null : respuesta[i].failure_cause_txt),
		            status: respuesta[i].new_status,
		            uniqueid: null,
		            trunk: null,
		            datetime_originate_start: respuesta[i].datetime_originate_start,
		            datetime_originate_end: respuesta[i].datetime_originate_end,
		            datetime_link_start: respuesta[i].datetime_link_start,
		            datetime_link_end: respuesta[i].datetime_link_end,
		            amd_status: respuesta[i].amd_status
		        };
		    } else {
		        // Se actualiza estado de intento previo
		        number_dialattempts[call_id].status = respuesta[i].new_status;
		        if (respuesta[i].duration != undefined)
		            number_dialattempts[call_id].duration = respuesta[i].duration;
		        if (respuesta[i].amd_status != undefined)
		            number_dialattempts[call_id].amd_status = respuesta[i].amd_status;
                if (respuesta[i].failure_cause != undefined)
                    number_dialattempts[call_id].failure_cause = respuesta[i].failure_cause;
                if (respuesta[i].failure_cause_txt != undefined)
                    number_dialattempts[call_id].failure_cause_txt = respuesta[i].failure_cause_txt;
                if (respuesta[i].datetime_originate_start != undefined)
                    number_dialattempts[call_id].datetime_originate_start = respuesta[i].datetime_originate_start;
                if (respuesta[i].datetime_originate_end != undefined)
                    number_dialattempts[call_id].datetime_originate_end = respuesta[i].datetime_originate_end;
                if (respuesta[i].datetime_link_start != undefined)
                    number_dialattempts[call_id].datetime_link_start = respuesta[i].datetime_link_start;
                if (respuesta[i].datetime_link_end != undefined)
                    number_dialattempts[call_id].datetime_link_end = respuesta[i].datetime_link_end;
		    }
		    // TODO: agent_number existe pero no hay dónde colocarlo

		    if (select_numberid.val() == respuesta[i].number_id) {
		        // Se ha recibido progreso sobre número que se está mostrando
		        select_numberid.change()
		    }
		    recalcular_navegacion_manualdialing();
		    break;
		case 'manualcontactnumber':
		    if ($('select#manualdialing_campaign_id').val() != respuesta[i].campaign_id)
		        break;
            var tr_contacto = $('div#elastix-callcenter-campanias-manuales-contactos > table > tbody > tr.contacto_seleccionado');
            if (tr_contacto.data('campaign_id') != respuesta[i].campaign_id)
                break;
            if (tr_contacto.data('contact_id') != respuesta[i].contact_id)
                break;

            var new_data = {
                id: respuesta[i].number_id,
                phone: respuesta[i].phone,
                dialattempts: {},
                agent_create: respuesta[i].agent_number,
                date_init: ((respuesta[i].schedule != undefined) ? respuesta[i].schedule.date_init : null),
                date_end:  ((respuesta[i].schedule != undefined) ? respuesta[i].schedule.date_end : null),
                time_init:  ((respuesta[i].schedule != undefined) ? respuesta[i].schedule.time_init : null),
                time_end:  ((respuesta[i].schedule != undefined) ? respuesta[i].schedule.time_end : null),
            };

            // Localizar <option> en lista desplegable
            var select_numberid = $('select#manualdialing_campaign_contact_number_id');
            var option_numberid = select_numberid.children().filter(function(idx) {
                return ($(this).data('id') == respuesta[i].number_id);
            });
            if (option_numberid.length > 0) {
                // Modificación de número existente
                new_data.dialattempts = option_numberid.data('dialattempts');
                option_numberid.data(new_data);
                if (select_numberid.val() == respuesta[i].number_id) {
                    // Los datos modificados están visibles, refrescar
                    select_numberid.change();
                }
            } else {
                // Creación de número nuevo, se asume que no se muestra de inmediato
                $('<option/>')
                    .data(new_data)
                    .val(respuesta[i].number_id)
                    .text(respuesta[i].phone)
                    .appendTo(select_numberid);
            }
		    break;
		}
	}
}

function mostrar_mensaje_info(s)
{
	$('#elastix-callcenter-info-message-text').text(s);
	$('#elastix-callcenter-info-message').show('slow', 'linear', function() {
		setTimeout(function() {
			$('#elastix-callcenter-info-message').fadeOut();
		}, 5000);
	});
}

function mostrar_mensaje_error(s)
{
	$('#elastix-callcenter-error-message-text').text(s);
	$('#elastix-callcenter-error-message').show('slow', 'linear', function() {
		setTimeout(function() {
			$('#elastix-callcenter-error-message').fadeOut();
		}, 5000);
	});
}

function abrir_url_externo(urlopentype, url, urlcontact)
{
	if (urlopentype != null && ultimo_urlcontact != urlcontact) {
	    ultimo_urlcontact = urlcontact;
		switch (urlopentype) {
		case 'iframe':
			if (jqueryui_tabs_use_refresh) {
			    // Se quita la cejilla anterior. Se asume que se fue marcada con clase .externalurl
		    	$('#elastix-callcenter-cejillas-contenido').find('.ui-tabs-nav li.tab-externalurl').remove();
			    $('#tabs-externalurl').remove();

			    // Se agrega la nueva cejilla, si existe
			    if (url != null) {
			        $('#elastix-callcenter-cejillas-contenido').append(
			            '<div id="tabs-externalurl"><iframe scrolling="auto" height="450" frameborder="0" width="100%" src="' + url + '" /></div>');
			        $('<li class="tab-externalurl"><a href="#tabs-externalurl">'+externalurl_title+'</a></li>')
			            .appendTo('#elastix-callcenter-cejillas-contenido > .ui-tabs-nav');
			    }

			    // Aplicar cambios
			    $('#elastix-callcenter-cejillas-contenido').tabs('refresh');
		    } else {
                externalurl = url;
                $('#elastix-callcenter-cejillas-contenido').tabs('remove', '#tabs-externalurl');
                $('#elastix-callcenter-cejillas-contenido').tabs('add', '#tabs-externalurl', externalurl_title);
		    }
			break;
		case 'jsonp':
			$.ajax(url, {
				dataType: 'jsonp',
				context:	document
			});
			break;
		case 'window':
		default:
			window.open(url, '_blank');
			break;
		}
	}
}

function do_cargar_campania_contactos(campaign_id, nuevo_offset)
{
    var contact_tbody = $('div#elastix-callcenter-campanias-manuales-contactos > table > tbody');
    var limit = contact_tbody.data('limit');
    contact_tbody.empty();
    contact_tbody.append(tr_cargando_contacto);

    // Se limpia la información de contacto presentada anteriormente
    $('#elastix-callcenter-llamada-info')
        .css('color', '')
        .empty()
    $('#elastix-callcenter-campanias-manuales-contactinfo').hide();
    $('select#manualdialing_campaign_contact_number_id').empty().change();

    $('#btn_contacts_seek_first, #btn_contacts_seek_prev, #btn_contacts_seek_next, #btn_contacts_seek_last')
        .button('disable');
    $.get('index.php', {
        menu:           module_name,
        rawmode:        'yes',
        action:         'manualcontacts',
        campaign_id:    campaign_id,
        offset:         nuevo_offset,
        limit:          limit,
        dialableonly:   (contact_tbody.data('call_seek_behavior') != 'random-seek')
    }, function(respuesta) {
        verificar_error_session(respuesta);
        if (respuesta['action'] == 'error') {
            mostrar_mensaje_error(respuesta['message']);
            return;
        }

        contact_tbody.empty();
        contact_tbody.data('offset', nuevo_offset);
        contact_tbody.data('total', respuesta.data.total);
        if (respuesta.data.contacts.length > 0) {
            for (var i = 0; i < respuesta.data.contacts.length; i++) {
                var tr = tr_plantilla_contacto.clone();

                /* Las siguientes propiedades se asignan a través de .data():
                 * campaign_id
                 * contact_id
                 * dedicated
                 * processing_status
                 * skipped
                 * description
                 * reservation_agent
                 * reservation_datetime
                 */
                tr.data(respuesta.data.contacts[i]);
                var td_status = tr.children('td').first();
                var td_desc = td_status.next();

                // Atributos del contacto
                td_status.children('span').hide();
                if (respuesta.data.contacts[i].processing_status == 'finished')
                    td_status.children('span.finalizado').show();
                if (respuesta.data.contacts[i].processing_status == 'reserved')
                    td_status.children('span.reservado').show();
                if (respuesta.data.contacts[i].skipped)
                    td_status.children('span.saltado').show();

                td_desc.text(respuesta.data.contacts[i].description);
                contact_tbody.append(tr);
            }
        } else {
            // No hay contactos
            contact_tbody.append(tr_sin_contacto);
        }

        // Activación condicional de los botones de navegación
        activar_botones_navegacion_manual(nuevo_offset, limit, respuesta.data.total);
        $('span#contacto_pagina_actual').text(Math.ceil((nuevo_offset + limit) / limit));
        $('span#contacto_pagina_total').text(Math.ceil(respuesta.data.total / limit));

        recalcular_navegacion_manualdialing();

        // Si campaña no es aleatoria, se simula clic en primero (y único) contacto
        if (contact_tbody.data('call_seek_behavior') != 'random-seek') {
            contact_tbody.children('tr').first().click();
            $('div#elastix-callcenter-campanias-manuales-callattempts').height('21em');
        } else {
            $('div#elastix-callcenter-campanias-manuales-callattempts').height('9.5em');
        }
    })
    .fail(function() {
        mostrar_mensaje_error('Failed to connect to server to run request!');
    });
}

function activar_botones_navegacion_manual(offset, limit, total)
{
    $('#btn_contacts_seek_first, #btn_contacts_seek_prev, #btn_contacts_seek_next, #btn_contacts_seek_last')
        .button('disable');
    if (offset > 0) {
        $('#btn_contacts_seek_first, #btn_contacts_seek_prev').button('enable');
    }
    if (offset < total - limit) {
        $('#btn_contacts_seek_next, #btn_contacts_seek_last').button('enable');
    }
}

function do_cargar_contacto_info(campaign_id, contact_id)
{
    $.get('index.php', {
        menu:       module_name,
        rawmode:    'yes',
        action:     'manualcontactinfo',
        campaign_id:    campaign_id,
        contact_id:     contact_id
    }, function(respuesta) {
        verificar_error_session(respuesta);
        if (respuesta['action'] == 'error') {
            mostrar_mensaje_error(respuesta['message']);
            return;
        }

        var contact_tbody = $('div#elastix-callcenter-campanias-manuales-contactos > table > tbody');

        $('#elastix-callcenter-campanias-manuales-contactinfo').show();
//      console.debug(respuesta.data);

        // Cargar la información del contacto en panel "Información" como HTML
        $('#elastix-callcenter-llamada-info')
            .css('color', '')
            .empty()
            .append(respuesta.llamada_informacion);

        var select_contactnum = $('select#manualdialing_campaign_contact_number_id');
        select_contactnum.empty();
        if (respuesta.data.dialnumbers != undefined && respuesta.data.dialnumbers.length > 0) {
            for (var k = 0; k < respuesta.data.dialnumbers.length; k++) {
                // Reemplazar arreglo vacío con objeto vacío
                if ((respuesta.data.dialnumbers[k].dialattempts instanceof Array) && respuesta.data.dialnumbers[k].dialattempts.length <= 0)
                    respuesta.data.dialnumbers[k].dialattempts = {};
                $('<option/>')
                    .data(respuesta.data.dialnumbers[k])
                    .val(respuesta.data.dialnumbers[k].id)
                    .text(respuesta.data.dialnumbers[k].phone + ((respuesta.data.dialnumbers[k].time_init == null) ? '' : ' ('+scheduled_label+')'))
                    .appendTo(select_contactnum);
            }
        } else {
            $('<option>(no contacts)</option>')
                .data({
                    id: null,
                    phone: null,
                    dialattempts: {},
                    date_init: null,
                    date_end: null,
                    time_init: null,
                    time_end: null,
                    agent_create: '(none)'
                })
                .appendTo(select_contactnum);
        }
        select_contactnum.change();

        /* Recalcular estado de botones según estado del contacto. Esto se hace
         * aquí y no en click de tabla contacts porque al menos una transición
         * depende de revisar los intentos de marcado del contacto que sólo se
         * cargan en getcontactinfo. */
        recalcular_navegacion_manualdialing();

        // Avisar que el contacto ha sido visto
        $.post('index.php', {
            menu:       module_name,
            rawmode:    'yes',
            action:     'manualcontactsetviewed',
            campaign_id:    campaign_id,
            contact_id:     contact_id
        }, function(respuesta) {
            verificar_error_session(respuesta);
            if (respuesta['action'] == 'error') {
                mostrar_mensaje_error(respuesta['message']);
                return;
            }
        });

        /* Voy a asumir que el contacto es distinto del contacto anterior ya
         * marcado, y que por lo tanto el agente ya no va a querer agendar
         * el contacto anteriormente visto. */
        $('#btn_agendar_llamada').button('disable');

        var data_contacto = contact_tbody.children('tr.contacto_seleccionado').data();
        if (select_contactnum.children().length > 0 &&
            contact_tbody.data('auto_call_contact') &&
            !data_contacto.skipped && data_contacto.processing_status == 'pending') {

            // Sólo automarcar si no hay intentos previos de marcado
            var tbody_dialattempts = $('#elastix-callcenter-campanias-manuales-callattempts > table > tbody');
            if (tbody_dialattempts.children('tr').length <= 0) {
                $('#btn_manual_marcar').click();
            }
        }
    })
    .fail(function() {
        mostrar_mensaje_error('Failed to connect to server to run request!');
    });

}

function recalcular_navegacion_manualdialing()
{
    var contact_tbody = $('div#elastix-callcenter-campanias-manuales-contactos > table > tbody');
    var marcable = !(estadoCliente.waitingcall || estadoCliente.calltype != null);

    if (!marcable) {
        $('select#manualdialing_campaign_id').prop('disabled', true);
        $('#btn_contacts_seek_first, #btn_contacts_seek_prev, #btn_contacts_seek_next, #btn_contacts_seek_last')
            .button('disable');
        $('select#manualdialing_campaign_contact_number_id').prop('disabled', true);
        $('#btn_hangup').button('enable');
    } else {
        $('select#manualdialing_campaign_id').prop('disabled', false);

        activar_botones_navegacion_manual(contact_tbody.data('offset'),
            contact_tbody.data('limit'), contact_tbody.data('total'));
        $('select#manualdialing_campaign_contact_number_id').prop('disabled', false);
        $('#btn_hangup').button('disable');
    }

    // Si no hay contacto seleccionado, no se puede marcar/saltar/finalizar
    if (contact_tbody.children('tr.contacto_seleccionado').length <= 0) {
        $('#btn_manual_marcar, #btn_manual_saltar, #btn_manual_atendida').button('disable');
        return;
    }

    var data_contacto = contact_tbody.children('tr.contacto_seleccionado').data();
    if (data_contacto == undefined) return;

    /* El botón Dial debe estar activo si la consola está ociosa o en break, y
     * el contacto actual está pendiente y no está saltado. En cualquier otro
     * caso, se desactiva el botón */
    var t1 = (marcable && !data_contacto.skipped);

    if (t1 && data_contacto.processing_status == 'pending') {
        $('#btn_manual_marcar').button('enable');
    } else {
        $('#btn_manual_marcar').button('disable');
    }

    // Banderas de atención exitosa y de si se está atendiendo llamada manual
    var atencion_intentada = false;
    var atencion_exitosa = false;
    var atendiendo_llamada = false;
    $('select#manualdialing_campaign_contact_number_id > option').each(function (idx) {
        var dialattempts = $(this).data('dialattempts');
        for (var k in dialattempts) {
            atencion_intentada = true;
            if ((dialattempts[k].status == 'Success' || dialattempts[k].status == 'Hangup') && dialattempts[k].agent == console_agent) {
                atencion_exitosa = true;
                if (estadoCliente.calltype == 'manualdialing' &&
                    data_contacto.campaign_id == estadoCliente.campaign_id &&
                    k == estadoCliente.callid) {
                    atendiendo_llamada = true;
                }
            }
        }
    });

    /* El botón Skip debe estar activo si la consola está ociosa o en break,
     * y si el contacto actual está pendiente o reservado, y no está saltado. En
     * cualquier otro caso, se desactiva el botón. */
    if (t1 && (data_contacto.processing_status == 'pending' || data_contacto.processing_status == 'reserved') &&
        !(contact_tbody.data('call_seek_behavior') == 'sequential-skip-tried' && !atencion_intentada)) {
        $('#btn_manual_saltar').button('enable');
    } else {
        $('#btn_manual_saltar').button('disable');
    }

    /* El botón Reset debe estar activo si la consola está ociosa o en break,
     * sin importar el estado de pendiente o reservado o saltado del contacto. */
    if (marcable) {
        $('#btn_manual_reset').button('enable');
    } else {
        $('#btn_manual_reset').button('disable');
    }

    /* El botón Handled debe estar activo si la consola está ociosa o en break, y
     * el contacto actual está pendiente y no está saltado. Además, debe haber
     * al menos 1 intento de marcado exitoso para este contacto por parte de
     * este agente, en cualquier número */
    var finalizable = t1 && (data_contacto.processing_status == 'pending');
    if ((finalizable && atencion_exitosa) || atendiendo_llamada) {
        $('#btn_manual_atendida').button('enable');
    } else {
        $('#btn_manual_atendida').button('disable');
    }
}
