var module_name = null;
var template_formnode = null;
var template_formfield = null;

$(document).ready(function() {
    module_name = getCurrentElastixModule();

	if (typeof FORM_DEF == 'undefined') return;

	/* El campo nodes debe ser un hash, no un arreglo. Si existe la propiedad
	 * length, entonces es un arreglo creado a partir de definición vacía. */
	if (typeof FORM_DEF.nodes.length != 'undefined') {
		FORM_DEF.nodes = {};
	}

	// Esconder recuadro de error hasta que se deba mostrar un mensaje
	$('#message_error, .message_board').hide();

	// Preparar la plantilla para inserción de nodos
	var tbody_nodelist = $('#tbody_nodelist');
	template_formnode = $('#tbody_nodelist > tr').detach();
	template_formnode.addClass('formnode_row');

	// Insertar los campos del formulario existente (si existen)
	for (var node_id in FORM_DEF.nodes) {
		var formnode = template_formnode.clone();
		var node = FORM_DEF.nodes[node_id];

		formnode.find('input[name="formnode_id"]').val(node_id);
		if (FORM_DEF.id_top_node == node_id) {
			formnode.find('input[name="formnode_id"]').prop('checked', true);
			$('#top_node').text(node.name);
			formnode.find('input[name="formnode_del"]').prop('disabled', true);
		}
		formnode.find('input[name="formnode_name"]').val(node.name);
		formnode.find('input[name="formnode_add"]').hide();
		tbody_nodelist.append(formnode);
	}

	// Insertar el campo preparado para agregar nuevo campo
	agregar_fila_nuevo_nodo();

	// Manejadores para interacción de modificación de nodos
	$(this).on('focus', 'tr.formnode_row > td.formnode_name > input[name="formnode_name"]', function() {
		$(this).parents('tr.formnode_row').click();
	});
	$(this).on('change', 'tr.formnode_row > td.formnode_name > input[name="formnode_name"]',
		actualizar_nombre_nodo);
	$(this).on('keyup', 'tr.formnode_row > td.formnode_name > input[name="formnode_name"]',
		actualizar_nombre_nodo);
	$(this).on('click','tr.formnode_row input[name="formnode_add"]', function() {
		/* Al hacer clic en el botón de agregar campo, el campo tiene que tener
		 * una etiqueta no vacía.
		 * Si las precondiciones fallan, se enfoca el control correspondiente.
		 * Si se cumplen, se quita la clase formfield_new, se agrega una nueva
		 * fila vacía. Además los nuevos campos de datos se recogen para crear
		 * el nuevo nodo. */
		var formnode = $(this).parents('tr.formnode_row');
		var formnode_name = formnode.find('input[name="formnode_name"]');
		if (formnode_name.val().trim() == '') {
			formnode_name.focus();
			return;
		}

		indicar_modificacion();

		// Se agrega fila a listado
		formnode.removeClass('formfield_new');
		formnode_name.attr('placeholder', '');
		formnode.find('input[name="formnode_add"]').hide();
		formnode.find('input[name="formnode_del"]').show();
		formnode.find('input[name="formnode_id"]').show();
		formnode.find('span.formnode_refcount').show();
		agregar_fila_nuevo_nodo();

		$('tr.formnode_new input[name="formnode_name"]').focus();
	});
	$(this).on('click','tr.formnode_row input[name="formnode_del"]', function(event) {
		// Impedir que se ejecute click() en tr.formnode_row
		event.stopPropagation();
		var formnode = $(this).parents('tr.formnode_row');

		console.debug('TODO: prohibir remoción si cuenta de referencias > 0');

		/* Si el nodo a borrar era el nodo actualmente en edición, se debe de
		 * asignar el nuevo nodo a editar como el nodo siguiente. No puede
		 * ocurrir que no exista el nodo siguiente, porque el último nodo
		 * no se puede quitar. */
		if (formnode.hasClass('formnode_current')) {
			seleccionar_editor_nodo(formnode.next());
		}

		/* Al hacer clic en el botón de quitar campo, la fila debe de desaparecer,
		 * y el ID de nodo correspondiente debe de agregarse a la lista denominada
		 * nodes_to_delete en FORM_DEF. */
		var nodekey = formnode.find('input[name="formnode_id"]').val();
		if (nodekey[0] != 'T') {
			// Sólo agregar a nodes_to_delete si nodo no es temporal
			if (typeof FORM_DEF.nodes_to_delete == 'undefined')
				FORM_DEF.nodes_to_delete = new Array;
			FORM_DEF.nodes_to_delete.push(nodekey);
		}
		formnode.remove();
		delete FORM_DEF.nodes[nodekey];
		actualizar_nodos_disponibles_rutas();
		indicar_modificacion();
	});
	$(this).on('change', 'tr.formnode_row input[name="formnode_id"]', function() {
		/* Al elegir un botón radio, se debe de actualizar el ID de nodo inicial,
		 * y el nombre del nodo que se muestra en la información global. Además
		 * se deben de activar todos los botones de quitar, y luego desactivar
		 * el que corresponde al control elegido. */
		FORM_DEF.id_top_node = $(this).val();
		indicar_modificacion();

		var formnode = $(this).parents('tr.formnode_row');
		$('#top_node').text(formnode.find('input[name="formnode_name"]').val());
		$('input[name="formnode_del"]').prop('disabled', false);
		formnode.find('input[name="formnode_del"]').prop('disabled', true);

		contar_referencias_nodos();
	});
	$(this).on('click', 'tr.formnode_row', function() {
		/* Al hacer clic en la fila del nodo, se debe de cargar la definición
		 * de los campos para este nodo. Se asume que todos los cambios a los
		 * campos fueron ya actualizados durante las modificaciones. */
		if ($(this).hasClass('formnode_current')) {
			// Se hizo clic en el mismo nodo que se modifica.
			return;
		}

		var formnode_anterior = $('#tbody_nodelist > tr.formnode_current');
		if (formnode_anterior.length > 0)
			cerrar_editor_nodo(formnode_anterior);
		$('#tbody_nodelist > tr').removeClass('formnode_current');
		seleccionar_editor_nodo($(this));
	});





	// Preparar la plantilla para inserción de campos
	var tbody_formlist = $('#tbody_fieldlist');
	template_formfield = $('#tbody_fieldlist > tr').detach();
	template_formfield.addClass('formfield_row');

	// Manejadores para interacción de modificación
	$(this).on('focus', 'tr.formfield_row > td.formfield_name > input[name="formfield_name"]', function() {
		$(this).parents('tr.formfield_row').click();
	});
	$(this).on('change', 'tr.formfield_row > td.formfield_name > input[name="formfield_name"]',
		actualizar_nombre_campo);
	$(this).on('keyup', 'tr.formfield_row > td.formfield_name > input[name="formfield_name"]',
		actualizar_nombre_campo);
	$(this).on('change', 'tr.formfield_row > td.formfield_enumval input[name="formfield_recyclable"]', function() {
		// Actualizar la bandera de reciclable
		var formfield = $(this).parents('tr.formfield_row');
		var field = formfield_hacia_field(formfield);
		if (field == undefined) return;

		field.recyclable = $(this).prop('checked');
		indicar_modificacion();
	});
	$(this).on('focus', 'tr.formfield_row > td.formfield_type > select', function() {
		$(this).parents('tr.formfield_row').click();
	});
	$(this).on('change', 'tr.formfield_row > td.formfield_type > select', function() {
		var formfield = $(this).parents('tr.formfield_row');
		var field = formfield_hacia_field(formfield);
		if (field == undefined) return;

		/* Los campos de tipo List y Route deben mostrar los controles de items.
		 * Otros tipos de campos deben de ocultarlos. */
		if ($(this).val() == 'List' || $(this).val() == 'Route') {
			formfield.find('td.formfield_enumval > span.formfield_enumval_wrap').show();
			if ($(this).val() == 'Route') {
				llenar_opciones_route(formfield, field);
			} else {
				llenar_opciones_list(formfield, field);
			}
		} else {
			formfield.find('td.formfield_enumval > span.formfield_enumval_wrap').hide();
		}

		field.type = $(this).val();
		indicar_modificacion();

		contar_referencias_nodos();
	});
	$(this).on('click', 'tr.formfield_row', function() {
		/* Al hacer clic en una fila, si el campo representado es LIST, se debe
		 * de mostrar el div de modificación de la lista. Todos los divs de
		 * todas las otras filas deben de ocultarse. */
		cerrar_enumlist_activos();

		$(this).find('span.formfield_enumval_passive').hide();
		$(this).find('div.formfield_enumval_active').show();
	});
	$(this).on('click', 'tr.formfield_row input[name="formfield_additem"]', function() {
		var formfield = $(this).parents('tr.formfield_row');
		var field = formfield_hacia_field(formfield);
		if (field == undefined) return;

		/* Al hacer clic en el botón de agregar item, se debe copiar el item
		 * a la lista de opciones, blanquear el text, y actualizar el span de
		 * opciones de vista pasiva. */
		var td_enumval = $(this).parents('td.formfield_enumval');
		var input_newitem = td_enumval.find('input[name="formfield_enumlist_newitem"]');
		var newitem = input_newitem.val().trim();

		if (newitem != '') {
			if (field.type == 'List') {
				field.options.push(newitem);
				llenar_opciones_list(formfield, field);
				input_newitem.val('');
			} else if (field.type == 'Route') {
				var routelist = td_enumval.find('select[name="formfield_enumlist_routes"]');
				var nodekey = routelist.val();
				console.debug('TODO: verificar que no hayan ciclos');
				console.debug('TODO: verificar que no se repitan etiquetas');
				console.debug('TODO: verificar que no se repitan IDs de nodos');
				if (true) {
					field.routes[newitem] = nodekey;
					llenar_opciones_route(formfield, field);
					input_newitem.val('');
					contar_referencias_nodos();
				}
			}
		}
		input_newitem.focus();
	});
	$(this).on('click', 'tr.formfield_row input[name="formfield_delitem"]', function() {
		var formfield = $(this).parents('tr.formfield_row');
		var field = formfield_hacia_field(formfield);
		if (field == undefined) return;

		/* Al hacer clic en el botón de quitar item, se debe remover el item que
		 * esté seleccionado de la lista de opciones, y actualizar el span de
		 * opciones de vista pasiva. */
		var selectedval = $(this).parents('td.formfield_enumval').find('select.formfield_enumlist_items option:selected').val();
		if (selectedval != undefined) {
			if (field.type == 'List') {
				// Se aprovecha que para List, valor es idéntico a texto de opción
				for (var i = 0; i < field.options.length; i++) {
					if (field.options[i] == selectedval) {
						field.options.splice(i, 1);
						break;
					}
				}
				llenar_opciones_list(formfield, field);
			} else if (field.type == 'Route') {
				delete field.routes[selectedval];
				llenar_opciones_route(formfield, field);
				contar_referencias_nodos();
			}
		}
		indicar_modificacion();
	});

	$(this).on('click','tr.formfield_row input[name="formfield_add"]', function() {
		/* Al hacer clic en el botón de agregar campo, el campo tiene que tener
		 * una etiqueta no vacía, y si es List, una lista de opciones no vacía.
		 * Si las precondiciones fallan, se enfoca el control correspondiente.
		 * Si se cumplen, se quita la clase formfield_new, se agrega una nueva
		 * fila vacía, y se reenumeran las filas. */
		var formfield = $(this).parents('tr.formfield_row');
		if (formfield.find('input[name="formfield_name"]').val().trim() == '') {
			formfield.find('input[name="formfield_name"]').focus();
			return;
		}
		if (formfield.find('td.formfield_type > select').val() == 'List') {
			if (formfield.find('select.formfield_enumlist_items > option').length <= 0) {
				formfield.find('input[name="formfield_enumlist_newitem"]').focus();
				return;
			}
		}

		// OK, se agrega fila a listado
		formfield.removeClass('formfield_new');
		formfield.attr('title', template_formfield.attr('title'));
		formfield.find('input[name="formfield_name"]').attr('placeholder', '');
		formfield.find('input[name="formfield_add"]').hide();
		formfield.find('input[name="formfield_del"]').show();
		agregar_fila_nuevo_campo();
		renumerar_campos();
		actualizar_nodos_disponibles_rutas();

		$('tr.formfield_new input[name="formfield_name"]').focus();
	});
	$(this).on('click','tr.formfield_row input[name="formfield_del"]', function() {
		/* Al hacer clic en el botón de quitar campo, la fila debe de desaparecer,
		 * y todos los campos restantes deben ser renumerados, a excepción del
		 * campo nuevo, cuya numeración quedará en blanco. */
		var formfield = $(this).parents('tr.formfield_row');
		var t = quitar_field_para_formfield(formfield);
		if (t == undefined) return;
		var field = t.field;
		var nodekey = t.nodekey;

		if (field.id[0] != 'T') {
			// Sólo agregar a fields_to_delete si campo no es temporal
			if (typeof FORM_DEF.fields_to_delete == 'undefined')
				FORM_DEF.fields_to_delete = new Array;
			FORM_DEF.fields_to_delete.push(field.id);
		}

		formfield.remove();
		renumerar_campos();
	});

	// Reordenamiento de campos del formulario
	$('#tbody_fieldlist').sortable({
		items: 'tr:not(.formfield_new)',
		stop: function(event, ui) {
			var formfield = ui.item;
			var t = quitar_field_para_formfield(formfield);
			if (t == undefined) return;
			var field = t.field;
			var nodekey = t.nodekey;

			// Averiguar ID de campo siguiente, el cual siempre existe
			var field_nextid = formfield.next().find('input[name="formfield_id"]').val();

			// Insertar en la posición correspondiente a siguiente ID
			for (var i = 0; i < FORM_DEF.nodes[nodekey].fields.length; i++) {
				if (FORM_DEF.nodes[nodekey].fields[i].id == field_nextid) {
					FORM_DEF.nodes[nodekey].fields.splice(i, 0, field);
					break;
				}
			}

			renumerar_campos();
		}
	});

	// Mandar los cambios al servidor
	$('input[name="save_new"]').on('click', function() {
		FORM_DEF.name = $('input[name="form_name"]').val();
		FORM_DEF.description = $('textarea[name="form_description"]').val();
		FORM_DEF.id_team = $('select[name="form_team"]').val();
		if (FORM_DEF.id_team == 0) FORM_DEF.id_team = null;
		var postvars = {
			menu:			module_name,
			action:			'save',
			rawmode:		'yes',
			data: FORM_DEF
		};
		//if (postvars.id == '') delete postvars.id;
		$.post('index.php', postvars, function (response) {
			if (response.action == 'error') {
				$('#mb_title').text(response.message.title);
				$('#mb_message').text(response.message.message);
				$('#message_error, .message_board').show().delay(10 * 1000).fadeOut(500);
			} else {
				window.open('?menu=' + module_name, '_parent');
			}
		});
	});

	$('input[name="save_new"]').prop('type', 'button');


	// Mostrar el editor de nodo para el primer nodo de la lista
	seleccionar_editor_nodo($('#tbody_nodelist > tr').first());
});

/**
 * Procedimiento que localiza el field que corresponde al formfield indicado,
 * lo quita de la definición del formulario, y entrega el nodekey y el field
 * afectados.
 *
 * @param formfield		Objeto jQuery del <tr> que corresponde al campo
 *
 * @returns	Object {nodekey, field}
 */
function quitar_field_para_formfield(formfield)
{
	var nodekey = clave_nodo_en_edicion();
	if (nodekey == undefined) return undefined;

	// Buscar el objeto y el índice del campo movido
	var field = undefined;
	var field_id = formfield_hacia_id(formfield);
	var field_oldidx = null;
	for (var i = 0; i < FORM_DEF.nodes[nodekey].fields.length; i++) {
		if (FORM_DEF.nodes[nodekey].fields[i].id == field_id) {
			field = FORM_DEF.nodes[nodekey].fields[i];
			field_oldidx = i;
		}
	}
	if (field == undefined) {
		alert('(internal) Field ' + field_id + ' not found in node ' + nodekey + '. This should not happen!');
		return undefined;
	}

	// Quitar el campo de la lista
	FORM_DEF.nodes[nodekey].fields.splice(field_oldidx, 1);

	indicar_modificacion();
	return {'nodekey': nodekey, 'field': field };
}

/**
 * Procedimiento que agrega una nueva fila en el estilo de ingreso de nuevo
 * nodo. Se genera un ID aleatorio temporal para identificar este nodo.
 *
 * @return void
 */
function agregar_fila_nuevo_nodo()
{
	// Generar un nuevo ID de nodo, y verificar colisión
	var tempkey;
	while (true) {
		tempkey = "T" + Math.random().toString();
		if (typeof FORM_DEF.nodes[tempkey] == 'undefined') break;
	}

	var formnode = template_formnode.clone();
	formnode.addClass('formfield_new');
	formnode.find('input[name="formnode_id"]').hide();
	formnode.find('input[name="formnode_id"]').val(tempkey);
	formnode.find('input[name="formnode_name"]').val('');
	formnode.find('input[name="formnode_del"]').hide();
	formnode.find('span.formnode_refcount').hide();
	$('#tbody_nodelist').append(formnode);

	FORM_DEF.nodes[tempkey] = {
		name:	'',
		fields:	[]
	};
}

/**
 * Procedimiento para actualizar el nombre del nodo. Este manejador se instala
 * para los eventos change y keyup, y asume que this se ha amarrado al método
 * con bind o similar.
 *
 * @return void
 */
function actualizar_nombre_nodo()
{
	/* Al modificar el contenido del input que representa el nombre del nodo,
	 * se propaga el cambio al objeto de nodo correspondiente. Este manejador
	 * sólo trata con los nodos existentes (guardados o temporales). El nodo
	 * por agregar se maneja al pulsar el botón de agregar. */
	var formnode = $(this).parents('tr.formnode_row');
	var nodekey = formnode.find('input[name="formnode_id"]').val();

	// Actualizar el nombre del nodo en FORM_DEF
	if (typeof FORM_DEF.nodes[nodekey] != 'undefined') {
		FORM_DEF.nodes[nodekey].name = $(this).val();
		actualizar_nodos_disponibles_rutas();
		indicar_modificacion();

		if (formnode.hasClass('formnode_current')) {
			$('span.formfield_legend').text($(this).val());
		}
	} else {
		alert('actualizar_nombre_nodo: NOT FOUND: ' + nodekey);
	}
}

/**
 * Procedimiento que reemplaza todos los campos mostrados en el editor de nodo
 * por los campos de la definición de nodo que corresponde al nodo indicado por
 * formnode.
 *
 * @param formnode	Object	Objeto jQuery de tipo <tr>
 *
 * @return void
 */
function seleccionar_editor_nodo(formnode)
{
	// Quitar todas las filas anteriores
	var tbody_formlist = $('#tbody_fieldlist');
	tbody_formlist.find('tr').remove();

	var nodekey = formnode.find('input[name="formnode_id"]').val();

	// Insertar los campos del formulario existente (si existen)
	if (typeof FORM_DEF.nodes[nodekey] == 'undefined') {
		alert('seleccionar_editor_nodo: NOT FOUND: ' + nodekey);
	} else {
		for (var i = 0; i < FORM_DEF.nodes[nodekey].fields.length; i++) {
			var formfield = template_formfield.clone();
			var field = FORM_DEF.nodes[nodekey].fields[i];

			formfield.find('span.formfield_order').text(i + 1);
			formfield.find('input[name="formfield_id"]').val(field.id);
			formfield.find('input[name="formfield_name"]').val(field.description);
			formfield.find('input[name="formfield_name"]').attr('placeholder', '');
			formfield.find('td.formfield_type > select').val(field.type);
			formfield.find('input[name="formfield_add"]').hide();
			if (field.type == 'List' || field.type == 'Route') {
				formfield.find('td.formfield_enumval > span.formfield_enumval_wrap').show();
				if (field.type == 'Route')
					llenar_opciones_route(formfield, field);
				else
					llenar_opciones_list(formfield, field);
			} else {
				formfield.find('td.formfield_enumval > span.formfield_enumval_wrap').hide();
			}

			formfield.find('td.formfield_enumval div.formfield_enumval_active').hide();
			tbody_formlist.append(formfield);
		}
	}

	// Insertar el campo preparado para agregar nuevo campo
	formnode.addClass('formnode_current');
	agregar_fila_nuevo_campo();
	actualizar_nodos_disponibles_rutas();

	$('span.formfield_legend').text(formnode.find('input[name="formnode_name"]').val());
}

/**
 * Procedimiento que finaliza la edición del nodo de formulario.
 *
 * @param formnode		Object	Objeto jQuery de tipo <tr>
 *
 * @return void
 */
function cerrar_editor_nodo(formnode)
{
	var nodekey = clave_nodo_en_edicion();
	if (nodekey == undefined) return;

	// Quitar de la definición del formulario el nodo temporal
	var formfield = $('#tbody_fieldlist tr.formfield_new');
	var field_id = formfield_hacia_id(formfield);
	if (FORM_DEF.nodes[nodekey].fields.length <= 0) {
		alert('(internal) node ' + nodekey + ' empty. This should not happen!');
	} else {
		var field = FORM_DEF.nodes[nodekey].fields.pop();
		if (field.id != field_id) {
			alert('(internal) node ' + nodekey + ' popped ' + field.id + ', expected ' + field_id + '. This should not happen!');
		}
	}

	formnode.removeClass('formnode_current');
	$('span.formfield_legend').text('-');
}

function formfield_hacia_id(formfield)
{
	return formfield.find('input[name="formfield_id"]').val();
}

function formfield_hacia_field(formfield)
{
	var nodekey = clave_nodo_en_edicion();
	if (nodekey == undefined) return;

	// Localizar el objeto field correspondiente al campo en edición
	var field = undefined;
	var field_id = formfield_hacia_id(formfield);
	for (var i = 0; i < FORM_DEF.nodes[nodekey].fields.length; i++) {
		if (FORM_DEF.nodes[nodekey].fields[i].id == field_id)
			field = FORM_DEF.nodes[nodekey].fields[i];
	}
	if (field == undefined) {
		alert('(internal) Field ' + field_id + ' not found in node ' + nodekey + '. This should not happen!');
	}
	return field;
}

function llenar_opciones_route(formfield, field)
{
	var enumlist = formfield.find('td.formfield_enumval select.formfield_enumlist_items');
	enumlist.empty();
	formfield.find('td.formfield_enumval > span.formfield_enumval_wrap select[name="formfield_enumlist_routes"]').show();
	for (var routekey in field.routes) {
		// TODO: verificar que field.routes[routekey] realmente es clave en FORM_DEF.nodes
		var opt = $('<option></option>')
			.text("'" + routekey + "' redirects '" + FORM_DEF.nodes[field.routes[routekey]].name + "'")
			.val(routekey);
		enumlist.append(opt);
	}
	formfield.find('td.formfield_enumval input[name="formfield_recyclable"]').prop('checked', field.recyclable);
	formfield.find('td.formfield_enumval span.formfield_enumval_passive').html(construir_lista_rutas(enumlist));
}

function llenar_opciones_list(formfield, field)
{
	var enumlist = formfield.find('td.formfield_enumval select.formfield_enumlist_items');
	enumlist.empty();
	formfield.find('td.formfield_enumval > span.formfield_enumval_wrap select[name="formfield_enumlist_routes"]').hide();
	for (var j = 0; j < field.options.length; j++) {
		var opt = $('<option></option>')
			.text(field.options[j])
			.val(field.options[j]);
		enumlist.append(opt);
	}
	formfield.find('td.formfield_enumval input[name="formfield_recyclable"]').prop('checked', field.recyclable);
	formfield.find('td.formfield_enumval span.formfield_enumval_passive').text(construir_lista_comas(enumlist));
}

/**
 * Procedimiento que actualiza el GUI para indicar que hay cambios no guardados.
 *
 * @return void
 */
function indicar_modificacion()
{
	console.debug('TODO: indicar formulario modificado');
}

// Leer la clave del nodo actualmente en edición
function clave_nodo_en_edicion()
{
	var clave = $('#tbody_nodelist > tr.formnode_current input[name="formnode_id"]').val();
	if (typeof clave == 'undefined') {
		alert('(internal) No node selected for editing. This should not happen!');
	} else if (typeof FORM_DEF.nodes[clave] == 'undefined') {
		alert('(internal) Node ' + clave + ' selected for editing does not exist in backing store. This should not happen!');
		clave = undefined;
	}
	return clave;
}

function agregar_fila_nuevo_campo()
{
	var nodekey = clave_nodo_en_edicion();
	if (nodekey == undefined) return;

	// Generar un nuevo ID de campo, y verificar colisión
	var tempkey;
	while (true) {
		tempkey = "T" + Math.random().toString();
		if (typeof FORM_DEF.nodes[nodekey].fields[tempkey] == 'undefined') break;
	}

	var formfield = template_formfield.clone();
	formfield.addClass('formfield_new');
	formfield.attr('title', null);
	formfield.find('span.formfield_order').text('');
	formfield.find('input[name="formfield_id"]').val(tempkey);
	formfield.find('input[name="formfield_name"]').val('');
	formfield.find('td.formfield_type > select').val('Text');
	formfield.find('input[name="formfield_del"]').hide();
	formfield.find('td.formfield_enumval > span.formfield_enumval_wrap').hide();
	formfield.find('td.formfield_enumval div.formfield_enumval_active').hide();
	$('#tbody_fieldlist').append(formfield);

	FORM_DEF.nodes[nodekey].fields.push({
		description:	'',
		id:				tempkey,
		recyclable:		false,
		type:			'Text',
		routes:			{},
		options:		[]
	});
	indicar_modificacion();
}

/**
 * Procedimiento para re-enumerar campos en el GUI. No es necesario renumerarlos
 * en la definición del formulario porque el orden en que se encuentra ya tiene
 * esta información.
 *
 * @returns void
 */
function renumerar_campos()
{
	var nodekey = clave_nodo_en_edicion();
	if (nodekey == undefined) return;

	$('#tbody_fieldlist > tr.formfield_row').not('.formfield_new').each(function(i) {
		$(this).find('span.formfield_order').text(i + 1);
	});
}

function cerrar_enumlist_activos()
{
	$('tr.formfield_row').find('div.formfield_enumval_active').hide();
	$('tr.formfield_row').find('span.formfield_enumval_passive').show();
}

// Construir el texto del estado pasivo de una lista
function construir_lista_comas(o)
{
	return o.find('option').map(function(i) { return $(this).val(); }).get().join(', ');
}

// Construir el texto del estado pasivo de una ruta
function construir_lista_rutas(o)
{
	var sp = $('<span></span>');
	o.find('option').each(function() {
		sp.append($('<p></p>').text($(this).text()));
	});
	return sp;
}

function actualizar_nodos_disponibles_rutas()
{
	var route_sels = $('select[name="formfield_enumlist_routes"]');
	var routes_available = false;

	route_sels.empty();
	for (var nodekey in FORM_DEF.nodes) {
		if (FORM_DEF.nodes[nodekey].name != '') {
			var opt = $('<option></option>')
				.text(FORM_DEF.nodes[nodekey].name)
				.val(nodekey);
			route_sels.append(opt);
			routes_available = true;
		}
	}
	route_sels.prop('disabled', !routes_available);

	contar_referencias_nodos();
}

/**
 * Procedimiento para actualizar el nombre del campo. Este manejador se instala
 * para los eventos change y keyup, y asume que this se ha amarrado al método
 * con bind o similar.
 *
 * @return void
 */
function actualizar_nombre_campo()
{
	var formfield = $(this).parents('tr.formfield_row');

	var field = formfield_hacia_field(formfield);
	if (field == undefined) return;

	field.description = $(this).val();
	indicar_modificacion();
}

/**
 * Procedimiento para recalcular la cuenta de referencias a los nodos dentro
 * de la totalidad del formulario.
 *
 * @return void
 */
function contar_referencias_nodos()
{
	//console.debug('TODO: recalcular cuenta de referencias a nodos');

	// Contar la cuenta de referencias a través de todo el formulario
	var noderef = {};
	for (var nodekey in FORM_DEF.nodes) { noderef[nodekey] = 0; }
	for (var nodekey in FORM_DEF.nodes) {
		for (var i = 0; i < FORM_DEF.nodes[nodekey].fields.length; i++) {
			if (FORM_DEF.nodes[nodekey].fields[i].type == 'Route') {
				for (var nodelabel in FORM_DEF.nodes[nodekey].fields[i].routes) {
					noderef[FORM_DEF.nodes[nodekey].fields[i].routes[nodelabel]]++;
				}
			}
		}
	}
	noderef[FORM_DEF.id_top_node]++;

	// Asignar su cuenta correspondiente a cada fila del nodo
	$('#tbody_nodelist tr').each(function () {
		var nodekey = $(this).find('input[name="formnode_id"]').val();
		$(this).find('span.formnode_refcount').text(noderef[nodekey]);
	});
}